package com.mh.eems;

import org.mybatis.spring.annotation.MapperScan;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.boot.builder.SpringApplicationBuilder;
import org.springframework.boot.web.servlet.support.SpringBootServletInitializer;
import org.springframework.cache.annotation.EnableCaching;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.mh.eems.job.QuartzManage;
import com.mh.eems.job.UpdateStatusJob;
import org.springframework.web.client.RestTemplate;

/**
 * 
 * @ClassName:  QuartzApplication   
 * @Description:TODO(启动项)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年6月12日 下午4:27:48   
 *
 */
//@EnableCaching
@SpringBootApplication
@EnableAutoConfiguration(exclude={DataSourceAutoConfiguration.class})
//@ComponentScan(basePackages= {"com.mh.eems.controller","com.mh.eems.*"})
@MapperScan("com.mh.eems.mapper")
//@RestController
@EnableScheduling			// 启动定时任务
//@EnableCaching       //缓存

public class QuartzApplication extends SpringBootServletInitializer {
	
	// 日志
	private static final Logger logger = LoggerFactory.getLogger(QuartzApplication.class); 
		
	@Override
	protected SpringApplicationBuilder configure(SpringApplicationBuilder application) {
		return application.sources(QuartzApplication.class);
	}

	public static void main(String[] args) {
		SpringApplication.run(QuartzApplication.class, args);
//		logger.debug(">>>>>>>>>>>>启动程序开始");
//		String job_name = null;
//		try {
//			Thread.sleep(10);
//			
//			job_name = "update_device_gateway_job";
//			logger.info(">>>>>>>>>>>>>>>--------每59分钟定时更新一次水表状态");
//			QuartzManage.addJob(job_name, UpdateStatusJob.class, "0 0/59 * * * ? ");
//
//		} catch (InterruptedException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		} catch (Exception e) {
//			e.printStackTrace();
//			logger.info(">>>>>>>>>>>>>>>--------【移除定时】开始...");
//			System.out.println("【移除定时】开始...");
//			QuartzManage.removeJob(job_name);
//			QuartzManage.shutdownJobs();
//			logger.info(">>>>>>>>>>>>>>>--------停止调动】成功");
//		}
	}

	@RequestMapping("/hello")
	public String Hello() {
		return "success";
	}

}
