package com.mh.eems.controller;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSONObject;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.DValueEntity;
import com.mh.eems.service.DValueService;
import com.mh.eems.util.DValueUtil;

/**
 * 
 * @ClassName:  DValueController   
 * @Description:TODO(总分差值前端接口值)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月14日 下午3:30:19   
 *
 */
@RestController
@RequestMapping("/dValue")
public class DValueController {
	
	@Autowired
	private DValueService dValueService;
	
//	private List<DValueEntity> list1;
	
	@GetMapping("/queryAll")
	public Object queryAll(@RequestParam(value="startTime",required=false) String startTime,
			@RequestParam(value="endTime",required=false) String endTime,
			@RequestParam(value="queryType",required=false) String queryType,
			@RequestParam(value="nodeName",required=false) String nodeName,
			@RequestParam(value="level",required=false) Integer level,
			@RequestParam(value="page",required=false) Integer page,
			@RequestParam(value="limit",required=false) Integer limit) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		Map<String, Object> map = new HashMap<String, Object>();
		
		if (startTime == null || startTime.equals("")) {
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(new Date());
			calendar.set(Calendar.HOUR, calendar.get(Calendar.HOUR) - 7);// 前七小时
			startTime  = new SimpleDateFormat("yyyy-MM-dd HH:00:00").format(calendar.getTime());
		}
		if (endTime == null || endTime.equals("")) {
			Calendar calendar1 = Calendar.getInstance();
			calendar1.setTime(new Date());
			calendar1.set(Calendar.HOUR, calendar1.get(Calendar.HOUR));// 前1小时
			endTime = new SimpleDateFormat("yyyy-MM-dd HH:00:00").format(calendar1.getTime());
		}
		if (queryType == null) {
			queryType = "hour";
		}
		
		map.put("startTime", startTime);
		map.put("endTime", endTime);
		map.put("queryType", queryType);
		map.put("nodeName", nodeName);
		map.put("level", level);
		map.put("page", page);
		map.put("limit", limit);
		map.put("status", 0);
		List<DValueEntity> list =dValueService.queryDValue(map);
//		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		int count = (int) map.get("result_count");
//		System.out.println("总数目："+ count);
		
		Map<String, Object> map1 = new HashMap<String, Object>();
		map1.put("startTime", startTime);
		map1.put("endTime", endTime);
		map1.put("queryType", queryType);
		map1.put("nodeName", nodeName);
		map1.put("level", level);
		map1.put("page", page);
		map1.put("limit", limit);
		map1.put("status", 1);
		List<DValueEntity> list1 =dValueService.queryDValue(map1);
		
		// 全查询数据
//		ResponseEntity<DValueEntity> pEntity = new ResponseEntity<DValueEntity>();
//		pEntity.setCode(200);
//		pEntity.setMsg("查询成功");
//		pEntity.setCount(count);
//		pEntity.setData(list);
//		return JSON.toJSON(pEntity);
		
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("code", 200);
		jsonObject.put("msg", "查询成功");
		jsonObject.put("count", count-1); 	// 减一是减去合计行
		jsonObject.put("data", list);
		jsonObject.put("total", list1);
		System.out.println(jsonObject);
		return jsonObject;
		
	}
	
	// 默认查询全部片区图标所需要数据
	@GetMapping("/queryAllChart")
	public Object queryAllChart(@RequestParam(value="startTime",required=false) String startTime,
			@RequestParam(value="endTime",required=false) String endTime,
			@RequestParam(value="queryType",required=false) String queryType,
			@RequestParam(value="nodeName",required=false) String nodeName,
			@RequestParam(value="level",required=false) Integer level,
			@RequestParam(value="page",required=false) Integer page,
			@RequestParam(value="limit",required=false) Integer limit) {
		DValueUtil dValueUtil = new DValueUtil();
		
		if (startTime == null || startTime.equals("")) {
			Calendar calendar = Calendar.getInstance();
			calendar.setTime(new Date());
			calendar.set(Calendar.HOUR, calendar.get(Calendar.HOUR) - 7);// 前七小时
			startTime  = new SimpleDateFormat("yyyy-MM-dd HH:00:00").format(calendar.getTime());
		}
		if (endTime == null || endTime.equals("")) {
			Calendar calendar1 = Calendar.getInstance();
			calendar1.setTime(new Date());
			calendar1.set(Calendar.HOUR, calendar1.get(Calendar.HOUR));// 前1小时
			endTime  = new SimpleDateFormat("yyyy-MM-dd HH:00:00").format(calendar1.getTime());
		}
		if (queryType == null) {
			queryType = "hour";
		}
		Object jsonObject = dValueUtil.queryAllChart(startTime, endTime, queryType, nodeName, level, page, limit);
		return jsonObject;
	}
	
}
