package com.mh.eems.controller;

import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.List;
import java.util.logging.Logger;

import com.alibaba.excel.EasyExcelFactory;
import com.alibaba.excel.metadata.Sheet;
import com.mh.eems.entity.Excel2ExchangeDeviceEntity;
import com.mh.eems.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.mh.eems.annotation.LogAnnotation;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.dto.ResultDto;
import com.mh.eems.entity.HistoryByHandEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.service.HistoryByHandService;
import com.mh.eems.util.JsonPackUtils;
import org.springframework.web.multipart.MultipartFile;
import sun.rmi.runtime.Log;

import javax.servlet.http.HttpServletRequest;

/**
 * @ClassName: HistoryByHandController
 * @Description:TODO(手抄记录前端接口层)
 * @author: 铭汉科技—LJF
 * @date: 2019年8月9日 下午2:09:43
 */
@RestController
@RequestMapping("/historyByHand")
public class HistoryByHandController {

    @Autowired
    private HistoryByHandService historyByHandService;

	/**
	 *  通过excel批量导入数据
	 * @param file
	 * @param request
	 * @param <T>
	 * @return
	 */
    @RequestMapping("/importExp")
    @ResponseBody
    public <T> Object importExp(@RequestParam("file") MultipartFile file, HttpServletRequest request) {
        // 判断文件是否为空
        JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
        HistoryByHandEntity historyByHandEntity = null;
        Object object=null;
        String  msg="";
      //  object = JSON.toJSON(jsonPackUtils.error("导入excel失败，数据重复或者格式错误，请重新导入"));
        if (!file.isEmpty()) {
            try {
                String originalFilename = file.getOriginalFilename();//原文件名字
                System.out.println("文件名：" + originalFilename);
                InputStream inputStream = file.getInputStream();//获取输入流
                BufferedInputStream bufferedInputStream = new BufferedInputStream(inputStream);
                DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
                List<Object> data = EasyExcelFactory.read(bufferedInputStream, new Sheet(1, 2, HistoryByHandEntity.class));        // 第几张工作表，第几行开始，javamodel
                inputStream.close();
                // 避免出现RPC 请求中提供了过多的参数。最多应为 2100报错，循环分批次插入update by ljf on 2019-08-23
                int batchLastIndex = 0;// 每批最后一个的下标
                for (int index = 0; index <= data.size(); index++) {
                    try {
                        historyByHandEntity = (HistoryByHandEntity) data.get(index);
                    } catch (Exception e) {

                    }
                    ResultDto resultDto = historyByHandService.insertHistory(historyByHandEntity, 1);
                    if (resultDto.getResult().equals("添加成功")) {
                        batchLastIndex = index;
                        System.out.println(resultDto.getResult() + ":" + historyByHandEntity.toString());
                    } else {
                      msg =  resultDto.getResult();
                      System.out.println(msg);
                        break;
                    }
                }
                System.out.println("批量插入长度：" + data.size());
                if (batchLastIndex == data.size()) {
                    object = JSON.toJSON(jsonPackUtils.ok("导入" + originalFilename + "成功"));
                    System.out.println(object.toString());
                }else{
                    object = JSON.toJSON(jsonPackUtils.error(msg));
                }
                StringUtil stringUtil = new StringUtil();
                stringUtil.print(data);
            } catch (Exception e) {
                 object = JSON.toJSON(jsonPackUtils.error("导入excel失败，数据重复或者格式错误，请重新导入"));
                e.printStackTrace();
            }
        }
        return object;
    }
    //暂时未启用
    @RequestMapping("/importExp1")
    @ResponseBody
    public <T> Object importExp1(@RequestParam("file") MultipartFile file, HttpServletRequest request) {
        // 判断文件是否为空
        JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
        Object object;
        object = JSON.toJSON(jsonPackUtils.error("导入excel失败，数据重复或者格式错误，请重新导入"));
        if (!file.isEmpty()) {
            try {
                String originalFilename = file.getOriginalFilename();//原文件名字
                System.out.println("文件名：" + originalFilename);
                InputStream inputStream = file.getInputStream();//获取输入流
                BufferedInputStream bufferedInputStream = new BufferedInputStream(inputStream);
                DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
                List<Object> data = EasyExcelFactory.read(bufferedInputStream, new Sheet(1, 2, HistoryByHandEntity.class));        // 第几张工作表，第几行开始，javamodel
                //HistoryByHandEntity.class
                inputStream.close();
                // 避免出现RPC 请求中提供了过多的参数。最多应为 2100报错，循环分批次插入update by ljf on 2019-08-23
                int resultInt = 0;
                int batchCount = 150;// 每批commit的个数
                int batchLastIndex = batchCount;// 每批最后一个的下标
                for (int index = 0; index < data.size(); ) {
                    if (batchLastIndex >= data.size()) {
                        batchLastIndex = data.size();
                        resultInt *= historyByHandService.batchInsertHistoryByHand(data.subList(index, batchLastIndex));
                        System.out.println("index:" + index + " batchLastIndex:" + batchLastIndex);
                        break;// 数据插入完毕，退出循环
                    } else {
                        resultInt = resultInt * historyByHandService.batchInsertHistoryByHand(data.subList(index, batchLastIndex));
                        System.out.println("index:" + index + " batchLastIndex:" + batchLastIndex);
                        index = batchLastIndex;// 设置下一批下标
                        batchLastIndex = index + (batchCount - 1);
                    }
                }
                System.out.println("批量插入长度：" + data.size());
//			        int a = userService.batchInsert(data);
                if (batchLastIndex == data.size()) {
                    object = JSON.toJSON(jsonPackUtils.ok("导入" + originalFilename + "成功"));
                }
                StringUtil stringUtil = new StringUtil();
                stringUtil.print(data);
            } catch (Exception e) {
                object = JSON.toJSON(jsonPackUtils.error("导入excel失败，数据重复或者格式错误，请重新导入"));
                e.printStackTrace();
            }
        }
        return object;
    }

    @LogAnnotation(module = "抄表录入管理", logs = "查询全部抄表记录", type = "查询")
    @GetMapping("/queryAll")
    public Object queryAllRecords(int page, int limit) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        ResponseEntity<HistoryByHandEntity> responseEntity = new ResponseEntity<HistoryByHandEntity>();
        List<HistoryByHandEntity> users = historyByHandService.queryHistorys(page, limit);
        responseEntity.setCode(200);
        responseEntity.setMsg("success");
        responseEntity.setData(users);
        responseEntity.setCount(historyByHandService.queryHistoryCount());
        return JSON.toJSON(responseEntity);
    }

    // 添加资料
    @PostMapping("/add")
    @ResponseBody
    public <T> Object addHistoryByHand(@RequestBody HistoryByHandEntity historyByHandEntity) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
        Object object;
        try {
            ResultDto resultDto = historyByHandService.insertHistory(historyByHandEntity, 1);
            if (resultDto.getResult().equals("添加成功")) {
                object = JSON.toJSON(jsonPackUtils.ok(resultDto.getResult()));
            } else {
                object = JSON.toJSON(jsonPackUtils.error(resultDto.getResult()));
            }

        } catch (Exception e) {
            // TODO: handle exception
            object = JSON.toJSON(jsonPackUtils.error("添加" + historyByHandEntity.getHouseNum() + "失败"));
            e.printStackTrace();
        }
        return object;
    }

    // 修改资料
    @PostMapping("/update")
    @ResponseBody
    public <T> Object updateHistoryByHand(@RequestBody HistoryByHandEntity historyByHandEntity) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
        Object object;
        try {
            String resultDto = historyByHandService.updateHistory(historyByHandEntity);
            if (resultDto.equals("success")) {
                object = JSON.toJSON(jsonPackUtils.ok(resultDto));
            } else {
                object = JSON.toJSON(jsonPackUtils.error(resultDto));
            }

        } catch (Exception e) {
            // TODO: handle exception
            object = JSON.toJSON(jsonPackUtils.error("修改" + historyByHandEntity.getHouseNum() + "失败"));
            e.printStackTrace();
        }
        return object;
    }

    // 删除记录
    @RequestMapping("/delete")
    public <T> Object deleteHistoryByHand(@RequestParam(value = "id", required = false) Integer id) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
        Object object;
        try {
            int a = historyByHandService.deleteHistory(id);
            if (a != 0) {
                object = JSON.toJSON(jsonPackUtils.ok("删除成功"));
            } else {
                object = JSON.toJSON(jsonPackUtils.error("删除失败"));
            }
        } catch (Exception e) {
            // TODO: handle exception
            object = JSON.toJSON(jsonPackUtils.error("删除失败"));
            e.printStackTrace();
        }
        return object;
    }

}
