package com.mh.eems.controller;

import com.alibaba.fastjson.JSON;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.MasterWaterEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.mapper.MasterWaterMapper;
import com.mh.eems.service.MasterWaterService;
import org.apache.ibatis.annotations.Param;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Classname MasterWaterController
 * @Description 总水表前端接口层
 * @Date 2020-07-15 17:37
 * @Created by NING MEI
 */
@RestController
@RequestMapping("/masterWater")
public class MasterWaterController {
    @Autowired
    MasterWaterService masterWaterService;
    @Resource
    MasterWaterMapper masterWaterMapper;
    @GetMapping("/queryAll")
    public Object quertAll(@Param("page") Integer page, @Param("limit") Integer limit) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        String updateTime = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date());// new Date()为获取当前系统时间
//        updateTime =;
//        System.out.println(updateTime);
        Map<String, Object> map = new HashMap<>();
        map.put("tableName", updateTime.substring(0, 4) + updateTime.substring(5, 7));
        map.put("page", page = page == null ? 1 : page);
        map.put("limit", limit = limit == null ? 10 : limit);
        List<MasterWaterEntity> list = masterWaterService.queryAll(map);
        int i = 0;
        while (i < list.size()) {
            float mah = Float.valueOf(list.get(i).getmAH());
            list.get(i).setmAH(String.valueOf(mah/1000).substring(0,4)+"%");
            i++;
        }
        Object object = null;
        ResponseEntity<MasterWaterEntity> ResponseEntity = new ResponseEntity<MasterWaterEntity>();
        ResponseEntity.setData(list);
        ResponseEntity.setCode(200);
        ResponseEntity.setMsg("success");
        ResponseEntity.setCount(masterWaterService.queryCount());
        object = JSON.toJSON(ResponseEntity);
        System.out.println(object);
        return object;
    }
}
