package com.mh.eems.controller;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.PeakValleyEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.service.PeakValleyService;
import com.mh.eems.util.PeckValleyUtil;

/**
 * 
 * @ClassName:  PeckValleyController   
 * @Description:TODO(峰谷值分析请求接口)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月13日 下午2:19:05   
 *
 */
@RestController
@RequestMapping("/peckValley")
public class PeckValleyController {
	
	@Autowired
	private PeakValleyService peakValleyService;
	
	// 默认全查询片区的使用量
	@GetMapping("/queryAll")
	public Object queryAll(@RequestParam(value="level",required=false) Integer level,
			@RequestParam(value="name",required=false) String name,
			@RequestParam(value="page",required=false) Integer page,
			@RequestParam(value="limit",required=false) Integer limit,
			@RequestParam(value="curDate",required=false) String curDate) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		if (curDate == null) {
			Date date = new Date();
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
			curDate = sdf.format(date);
		}
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("code", level);
		map.put("name", name);
		map.put("cur_date", curDate);
		map.put("page", page);
		map.put("limit", limit);
		List<PeakValleyEntity> list =peakValleyService.queryPeakValleyByMap(map);
//		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		int count = (int) map.get("result_count");
//		System.out.println("总数目："+ count);
		
		// 全查询数据
		ResponseEntity<PeakValleyEntity> pEntity = new ResponseEntity<PeakValleyEntity>();
		pEntity.setCode(200);
		pEntity.setMsg("查询成功");
		pEntity.setCount(count);
		pEntity.setData(list);
		return JSON.toJSON(pEntity);
	}
	
	// 默认查询全部片区图标所需要数据
	@GetMapping("/queryAllChart")
	public Object queryAllChart(@RequestParam(value="level",required=false) Integer level,
			@RequestParam(value="name",required=false) String name,
			@RequestParam(value="page",required=false) Integer page,
			@RequestParam(value="limit",required=false) Integer limit,
			@RequestParam(value="curDate",required=false) String curDate) {
		if (curDate == null || curDate.equalsIgnoreCase("")) {
			Date date = new Date();
			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
			curDate = sdf.format(date);
		}
		PeckValleyUtil peckValleyUtil = new PeckValleyUtil();
		Object jsonObject = peckValleyUtil.queryAllChart(curDate, page, limit, level, name);
		return jsonObject;
	}

}
