package com.mh.eems.controller;

import java.text.DecimalFormat;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.ReporterEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.service.StatisticsService;

/**
 * @ClassName: ReporterController
 * @Description:TODO(统计报表接口)
 * @author: 铭汉科技—LJF
 * @date: 2019年10月31日 下午4:05:23
 */
@RestController
@RequestMapping("/statistics")
public class ReporterController {

    @Autowired
    private StatisticsService statisticsService;

    @GetMapping("/queryByOther")
    public Object queryStatisticsReportByOther(@RequestParam(value = "levelId", required = false) Integer levelId,
                                               @RequestParam(value = "levelName", required = false) String levelName,
                                               @RequestParam(value = "queryType", required = false) String queryType,
                                               @RequestParam(value = "page", required = false) Integer page,
                                               @RequestParam(value = "limit", required = false) Integer limit) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        Object resultJson = null;
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("levelId", levelId);
        map.put("levelName", levelName);
        map.put("queryType", queryType);
        map.put("page", page);
        map.put("limit", limit);
        try {
            List<ReporterEntity> list = statisticsService.queryStatisticsReport(map);
            //		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
            int count = (int) map.get("result_count");
            //		System.out.println("总数目："+ count);
            int i = 0;
            double excNum = 0;      //异常总数目
            double totalNum = 0;    //区域总和
            double failNum = 0;     //失败总和
            double suessNum = 0;    //成功总和
            long time1 = System.currentTimeMillis();
            while (i < list.size()) {
                //获取异常数量
                double exc = Float.parseFloat(list.get(i).getExceptionNum());
                //获取表总量
                double total = Integer.parseInt(list.get(i).getTotalNum());
                //获取失败数量
                double fail = Integer.parseInt(list.get(i).getFailNum());
                //获取成功数量
                double suess = Integer.parseInt(list.get(i).getSuccessNum());
                suessNum += suess;
                excNum += exc;
                totalNum += total;
                failNum += fail;
                if (total != 0.0) {                                //过滤掉总量为0   不能除以0
                    //计算百分比
                    if (exc != 0.0) {                                 //0除以任何数等于0
                        list.get(i).setExceptionRatio(String.valueOf((exc / total) * 100).substring(0, 3) + "%");
                    } else {
                        list.get(i).setExceptionRatio("0%");
                    }
                    if (fail != 0.0) {                           //0除以任何数等于0
                        list.get(i).setFailRatio(String.valueOf((fail / total) * 100).substring(0, 3) + "%");
                    }else {
                        list.get(i).setFailRatio("0%");
                    }
                    if(suess !=0.0){
                        list.get(i).setSuccessRatio(String.valueOf((suess / total) * 100).substring(0, 3) + "%");
                    }else {
                        list.get(i).setSuccessRatio("0%");
                    }

                 //   System.out.println(exc / total);
                } else {
                    list.get(i).setExceptionRatio("0%");
                    list.get(i).setFailRatio("0%");
                    list.get(i).setSuccessRatio("0%");
                }
                i++;
            }
            ReporterEntity reporterEntity = new ReporterEntity();
            reporterEntity.setAreaName("合计");
            reporterEntity.setSuccessNum(String.valueOf(suessNum));
            reporterEntity.setTotalNum(String.valueOf(totalNum));
            reporterEntity.setExceptionNum(String.valueOf(excNum));
            reporterEntity.setFailNum(String.valueOf(failNum));
            reporterEntity.setSuccessRatio(String.valueOf((double)((suessNum / totalNum) * 100)).substring(0, 3) + "%");
            reporterEntity.setExceptionRatio(String.valueOf((excNum / totalNum) * 100).substring(0, 3) + "%");
            reporterEntity.setFailRatio(String.valueOf((failNum / totalNum) * 100).substring(0, 3) + "%");
            reporterEntity.setCurTime(list.get(0).getCurTime());
            list.add(reporterEntity);
            long time2 = System.currentTimeMillis();
            System.out.println("代码开始到结束期间耗时：" + (time2 - time1) + "ms");
            // 全查询数据
            ResponseEntity<ReporterEntity> pEntity = new ResponseEntity<ReporterEntity>();
            pEntity.setCode(200);
            pEntity.setMsg("查询成功");
            pEntity.setCount(count);
            pEntity.setData(list);
            System.out.println(list.toString());
            resultJson = JSON.toJSONString(pEntity, SerializerFeature.PrettyFormat, SerializerFeature.WriteMapNullValue);
          //  System.out.println(JSON.toJSONString(pEntity, SerializerFeature.PrettyFormat, SerializerFeature.WriteMapNullValue));
        } catch (Exception e) {
            // TODO: handle exception
            e.printStackTrace();
        }
        return resultJson;

    }


}
