package com.mh.eems.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.entity.RoleEntity;
import com.mh.eems.entity.SysLogEntity;
import com.mh.eems.service.SysLogService;

/**
 * 
 * @ClassName:  SysLogController   
 * @Description:TODO(系统日志查询接口)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年7月30日 下午3:46:04   
 *
 */
@RestController
@RequestMapping("/sysLog")
public class SysLogController {
	
	@Autowired
	private SysLogService sysLogService;
	
	@GetMapping("/queryLogs")
	public Object queryLogs(@RequestParam(value="startTime", required=false) String startTime,
			@RequestParam(value="endTime", required=false) String endTime,
			@RequestParam(value="opType", required=false) String opType,
			@RequestParam(value="userName", required=false) String userName,
			@RequestParam(value="page", required=false) Integer page,
			@RequestParam(value="limit", required=false) Integer limit) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		ResponseEntity<SysLogEntity> responseEntity = new ResponseEntity<SysLogEntity>();
		try {
			List<SysLogEntity> sysLogEntities = sysLogService.querySysLogs(startTime, endTime, opType, userName, page, limit);
			responseEntity.setCode(200);
			responseEntity.setMsg("success");
			responseEntity.setData(sysLogEntities);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		responseEntity.setCount(sysLogService.querySysLogsCount(startTime, endTime, opType, userName, page, limit));
		System.out.println(JSONObject.toJSON(responseEntity));
		return JSON.toJSON(responseEntity);
	}

}
