package com.mh.eems.controller;

import java.util.Calendar;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.entity.UsageAnalysisEntity2;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import com.alibaba.fastjson.JSON;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.entity.UsageAnalysisEntity;
import com.mh.eems.service.UsageAnalysisService;
import com.mh.eems.util.UsageAnalysisUtil;

/**
 * @ClassName: UsageAnalysisController
 * @Description:TODO(使用量分析前端接口)
 * @author: 铭汉科技—LJF
 * @date: 2019年8月16日 下午3:10:32
 */

@RestController
@RequestMapping("/usageAnalysis")
public class UsageAnalysisController {
    @Autowired
    private UsageAnalysisService usageAnalysisService;

    // 查询使用量占比
    @GetMapping("/queryAll")
    public Object queryAll(@RequestParam(value = "level", required = false) Integer level,
                           @RequestParam(value = "nodeName", required = false) String nodeName,
                           @RequestParam(value = "time", required = false) String time,
                           @RequestParam(value = "page", required = false) Integer page,
                           @RequestParam(value = "limit", required = false) Integer limit) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
//		if (curDate == null) {
//			Date date = new Date();
//			SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
//			curDate = sdf.format(date);
//		}

        Map<String, Object> map = new HashMap<String, Object>();
        map.put("level", level);
        map.put("nodeName", (nodeName == null || nodeName.equals("")) ? null : nodeName);
        if (time == null || time.equals("")) {

        } else {

        }
        map.put("time", (time == null || time.equals("")) ? null : time);
        map.put("page", page);
        map.put("limit", limit);
        List<UsageAnalysisEntity> list = usageAnalysisService.queryUsageAnalysisByMap(map);

//		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
        int count = (int) map.get("result_count");
//		System.out.println("总数目："+ count);

        // 全查询数据
        ResponseEntity<UsageAnalysisEntity> pEntity = new ResponseEntity<UsageAnalysisEntity>();
        pEntity.setCode(200);
        pEntity.setMsg("查询成功");
        pEntity.setCount(count);
        pEntity.setData(list);
        System.out.println(JSON.toJSON(pEntity));
        return JSON.toJSON(pEntity);
    }

    // 查询使用量占比
    @GetMapping("/queryAll2")
    public Object queryAll2(@RequestParam(value = "level", required = false) Integer level,
                            @RequestParam(value = "nodeName", required = false) String nodeName,
                            @RequestParam(value = "time", required = false) String time,
                            @RequestParam(value = "page", required = false) Integer page,
                            @RequestParam(value = "limit", required = false) Integer limit) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        Calendar cal = Calendar.getInstance();
        String year = "2019 ~ " + Integer.toString(cal.get(Calendar.YEAR));
        nodeName = (nodeName == null || nodeName.equals("")) ? "狮山水务抄表系统" : nodeName;
        level = (level == null) ? 1 : level;
        time = (time == null || time.equals("")) ? year : time;
        page = (page == null || page.equals("")) ? 0 : page;
        limit = (limit == null || limit.equals("")) ? 0 : limit;
        Map<String, Object> map = new HashMap<String, Object>();
        int timeLen = time.length();
        map.put("level", level);
        map.put("nodeName", nodeName);
        map.put("timeLen", timeLen);
        map.put("time", time);
        map.put("page", page);
        map.put("limit", limit);
        List<UsageAnalysisEntity> list = usageAnalysisService.queryUsageAnalysisByMap2(map);
        System.out.println("返回end" + JSON.toJSONString(list, SerializerFeature.PrettyFormat, SerializerFeature.WriteMapNullValue));
        map.put("page", 0);
        int count = list.size();
        if (time.length() == 23 || time.length() == 17) {
            List<UsageAnalysisEntity> lists = usageAnalysisService.queryUsageAnalysisByMap2(map);
            count = lists.size();
            System.out.println("总数目：" + count);
            // 全查询数据
        }
        double ratio_Num = 0;
        int i = 0;
        while (i < list.size()) {
            ratio_Num += Double.parseDouble(list.get(i).getTotalUsed());
            i++;
        }
        for (int j = 0; j < list.size(); j++) {
            System.out.println();
            if(ratio_Num!=0) {
                list.get(j).setRatio(String.valueOf((Double.parseDouble(list.get(j).getTotalUsed()) / ratio_Num)*100).substring(0,5) + "%");
            }else {
                list.get(j).setRatio("0%");
            }
        }
        ResponseEntity<UsageAnalysisEntity> pEntity = new ResponseEntity<>();
        pEntity.setCode(200);
        pEntity.setMsg("查询成功");
        pEntity.setCount(count);
        pEntity.setData(list);
        return JSON.toJSON(pEntity);
    }

    // 首页页面的片区使用柱状图
    @GetMapping("/home")
    public Object queryAllHome() {
        UsageAnalysisUtil usageAnalysisUtil = new UsageAnalysisUtil();
        Object hObject = usageAnalysisUtil.queryChart();
        return hObject;
    }

}
