package com.mh.eems.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.alibaba.fastjson.JSON;
import com.mh.eems.annotation.LogAnnotation;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.NowUsageEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.entity.UsageEntity;
import com.mh.eems.service.UsageService;

/**
 * 用量查询
 * @author chison
 *
 */
@RestController
@RequestMapping("/usage")
public class UsageController {

	@Autowired
	private UsageService usageService;
	
	@LogAnnotation(module="用量管理", logs = "查询全部用量信息", type = "查询")
	@GetMapping("/queryAllUsage")
	public Object queryAllUsage(@RequestParam(required = false) Integer limit,
			@RequestParam(required = false) Integer page,@RequestParam(required = false) String timeType,
			@RequestParam(required = false) String houseNum,@RequestParam(required = false) String houseAddress,
			@RequestParam(required = false) String starTime,@RequestParam(required = false) String endTime,
			@RequestParam(required = false) Integer level,@RequestParam(required = false) String areaName) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		UsageEntity usageEntity=new UsageEntity();
		if(timeType==null||timeType=="") {
			usageEntity.setTimeType("day");
		}else {
			usageEntity.setTimeType(timeType);
		}
		if(limit==null) {
			usageEntity.setLimit(0);
		}else {
			usageEntity.setLimit(limit);
		}
		if(page==null) {
			usageEntity.setPage(0);
		}else {
			usageEntity.setPage(page);
		}
		if(starTime=="") {
			usageEntity.setStarTime(null);
		}else {
			usageEntity.setStarTime(starTime);
		}
		if(endTime=="") {
			usageEntity.setEndTime(null);
		}else {
			usageEntity.setEndTime(endTime);
		}
		if(houseNum=="") {
			usageEntity.setHouseNum(null);
		}else {
			usageEntity.setHouseNum(houseNum);
		}
		if(houseAddress=="") {
			usageEntity.setHouseAddress(null);
		}else {
			usageEntity.setHouseAddress(houseAddress);
		}
		if(areaName=="") {
			usageEntity.setAreaName(null);
		}else {
			usageEntity.setAreaName(areaName);
		}
		usageEntity.setLevel(level);
		
		
		List<UsageEntity> list=usageService.queryAllUsage(usageEntity);
		ResponseEntity<UsageEntity> responseEntity = new ResponseEntity<UsageEntity>();
		responseEntity.setCode(200);
		responseEntity.setMsg("success");
		responseEntity.setData(list);
		if(list.size()==0) {
			responseEntity.setCount(0);
		}else {
			responseEntity.setCount(list.get(0).getTotal());
		}
		return JSON.toJSON(responseEntity);
	}
	
	@GetMapping("/usageCount")
	//@ResponseBody
	public Object usageCount() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		List<UsageEntity> list=usageService.usageCount();
		ResponseEntity<UsageEntity> responseEntity = new ResponseEntity<UsageEntity>();
		responseEntity.setCode(200);
		responseEntity.setData(list);
		responseEntity.setMsg("success");
		return JSON.toJSON(responseEntity);
	}
	
	@GetMapping("/nowUsage")
	public Object nowUsage(@RequestParam(required = false) Integer limit,
			@RequestParam(required = false) Integer page,@RequestParam(required = false) String houseNum,
			@RequestParam(required = false) Integer level,@RequestParam(required = false) String areaName,
			@RequestParam(required = false) Integer searchType) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		NowUsageEntity nowUsageEntity=new NowUsageEntity();
		if(limit==null) {
			nowUsageEntity.setLimit(0);
		}else {
			nowUsageEntity.setLimit(limit);
		}
		if(page==null) {
			nowUsageEntity.setPage(0);
		}else {
			nowUsageEntity.setPage(page);
		}
		if(houseNum=="") {
			nowUsageEntity.setHouseNum(null);
		}else {
			nowUsageEntity.setHouseNum(houseNum);
		}
		if(areaName=="") {
			nowUsageEntity.setAreaName(null);
		}else {
			nowUsageEntity.setAreaName(areaName);
		}
		if(searchType==null) {
			nowUsageEntity.setStatus(102);
		}else {
			nowUsageEntity.setStatus(searchType);
		}
		nowUsageEntity.setLevel(level);
		List<NowUsageEntity> lists=usageService.nowUsage(nowUsageEntity);
		ResponseEntity<NowUsageEntity> responseEntity=new ResponseEntity<NowUsageEntity>();
		responseEntity.setCode(200);
		responseEntity.setData(lists);
		responseEntity.setMsg("success");
		if(lists.size()==0) {
			responseEntity.setCount(0);
		}else {
			responseEntity.setCount(lists.get(0).getCount());
		}
		return responseEntity;
	}
	
}
