package com.mh.eems.controller;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson.JSON;
import com.mh.eems.annotation.LogAnnotation;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.entity.UsageExceptionEntity;
import com.mh.eems.service.UsageExceptionService;

/***
 * 用量异常查询
 * @author chison
 *
 */
@RestController
@RequestMapping("/usageException")
public class UsageExceptionController {

	@Autowired
	private UsageExceptionService usageExceptionService;
	
	@LogAnnotation(module="用量异常管理", logs = "查询全部用量信息", type = "查询")
	@GetMapping("/queryException")
	public Object queryException(@RequestParam(required = false) Integer limit,
			@RequestParam(required = false) Integer page,@RequestParam(required = false) String areaName,
			@RequestParam(required = false) String starTime,@RequestParam(required = false) String endTime,
			@RequestParam(required = false) String usageType,@RequestParam(required = false) Integer level) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		UsageExceptionEntity param=new UsageExceptionEntity();
		if(page==null) {
			param.setPage(0);
		}else {
			param.setPage(page);
		}
		if(limit==null) {
			param.setLimit(0);
		}else {
			param.setLimit(limit);
		}
		if(areaName==null||areaName=="") {
			param.setAreaName("尚筑");
		}else {
			param.setAreaName(areaName);
		}
		if(level==null||level==1) {
			param.setLevel(3);
		}else {
			param.setLevel(level);
		}
		//获取前一个的时间
		Calendar c = Calendar.getInstance();
		c.setTime(new Date());
		c.add(Calendar.MONTH, -1);
		String startDate=new SimpleDateFormat("yyyy-MM").format(c.getTime());
		String date=new SimpleDateFormat("yyyy-MM").format(new Date());
		if(starTime==null||starTime=="") {
			param.setStarTime(startDate);
			param.setTableStarTime(startDate.split("-")[0]+startDate.split("-")[1]);
		}else {
			param.setStarTime(starTime);
			param.setTableStarTime(starTime.split("-")[0]+starTime.split("-")[1]);
		}
		if(endTime==null||endTime=="") {
			param.setEndTime(date);
			param.setTableEndTime(date.split("-")[0]+date.split("-")[1]);
		}else {
			param.setEndTime(endTime);
			param.setTableEndTime(endTime.split("-")[0]+endTime.split("-")[1]);
		}
		if(usageType==null || usageType.equals("0")) {
			param.setUsageType(null);
		}else {
			param.setUsageType(usageType);
		}
		System.out.println(param.toString());
		List<UsageExceptionEntity> lists=usageExceptionService.queryException(param);
		ResponseEntity<UsageExceptionEntity> responseEntity = new ResponseEntity<UsageExceptionEntity>();
		responseEntity.setCode(200);
		responseEntity.setMsg("success");
		responseEntity.setData(lists);
		if(lists.size()==0) {
			responseEntity.setCount(0);
		}else {
			responseEntity.setCount(lists.get(0).getCount());
		}
		return JSON.toJSON(responseEntity);
	}
	
	@GetMapping("/homeException")
	public Object homeException() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		List<UsageExceptionEntity> lists=usageExceptionService.homeException();
		ResponseEntity<UsageExceptionEntity> responseEntity = new ResponseEntity<UsageExceptionEntity>();
		responseEntity.setCode(200);
		responseEntity.setMsg("success");
		responseEntity.setData(lists);
		return JSON.toJSON(responseEntity);
	}
	
	@GetMapping("/percentException")
	public Object percentException(@RequestParam(required = false) Integer limit,
			@RequestParam(required = false) Integer page,@RequestParam(required = false) Double percent,
			@RequestParam(required = false) String percentType,@RequestParam(required = false) String areaName,
			@RequestParam(required = false) Integer level) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		UsageExceptionEntity param=new UsageExceptionEntity();
		Calendar c = Calendar.getInstance();
		c.setTime(new Date());
		param.setEndTime(new SimpleDateFormat("yyyy-MM").format(new Date()));
		param.setTableEndTime(new SimpleDateFormat("yyyyMM").format(new Date()));
		c.add(Calendar.MONTH,-1);
		param.setStarTime(new SimpleDateFormat("yyyy-MM").format(c.getTime()));
		c.add(Calendar.MONTH, -2);
		param.setTableStarTime(new SimpleDateFormat("yyyyMM").format(c.getTime()));
		
		if(page==null) {
			param.setPage(0);
		}else {
			param.setPage(page);
		}
		if(limit==null) {
			param.setLimit(0);
		}else {
			param.setLimit(limit);
		}
		if(percent==null) {
			param.setPercent(0.30);
		}else {
			param.setPercent(percent/100);
		}
		if(percentType==null||percentType=="") {
			param.setUsageType(null);
		}else {
			param.setUsageType(percentType);
		}
		if(areaName==null||areaName=="") {
			param.setAreaName("尚筑");
		}else {
			param.setAreaName(areaName);
		}
		if(level==null||level==1) {
			param.setLevel(3);
		}else {
			param.setLevel(level);
		}
		
		System.out.println(param.toString());
		
		List<UsageExceptionEntity> lists=usageExceptionService.percentException(param);
		ResponseEntity<UsageExceptionEntity> responseEntity = new ResponseEntity<UsageExceptionEntity>();
		responseEntity.setCode(200);
		responseEntity.setMsg("success");
		responseEntity.setData(lists);
		if(lists.size()>0) {
			responseEntity.setCount(lists.get(0).getCount());
		}
		return JSON.toJSON(responseEntity);
	}
	
	
}
