package com.mh.eems.controller;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.entity.UserFlowEntity;
import com.mh.eems.service.UserUsageAnalysisService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Classname UserUsageAnalysis
 * @Description 用户用量分析前端接口
 * @Date 2020-06-22 15:39
 * @Created by NING MEI
 */
@RestController
@RequestMapping("userUsageAnalysis")
public class UserUsageAnalysisController {
    @Autowired
    private UserUsageAnalysisService userUsageAnalysisService;
    @RequestMapping("queryByType")
    public Object queryByType(@RequestParam(value = "houseNum", required = false) String houseNum,
                              @RequestParam(value = "areaName", required = false) String areaName,
                              @RequestParam(value = "page", required = false) Integer page,
                              @RequestParam(value = "limit", required = false) Integer limit) {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        Map<String, Object> map = new HashMap<String, Object>();
        ResponseEntity<UserFlowEntity> responseEntity = new ResponseEntity<UserFlowEntity>();
        Object object = null;
        map.put("houseNum", houseNum);
        map.put("areaName", areaName);
        map.put("page", page);
        map.put("limit", limit);
        List<UserFlowEntity> list = userUsageAnalysisService.queryByType(map);
        System.out.println(JSON.toJSON(list));
        responseEntity.setData(list);
        responseEntity.setCode(200);
        responseEntity.setMsg("success");
        responseEntity.setCount(userUsageAnalysisService.queryCount());
        try {
            object = JSON.toJSONString(responseEntity, SerializerFeature.PrettyFormat, SerializerFeature.WriteMapNullValue);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
        System.out.println(object);
        return object;
    }
    @RequestMapping("queryAll")
    public Object queryAll() {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        Object object = null;
        ResponseEntity<UserFlowEntity> responseEntity = new ResponseEntity<UserFlowEntity>();
        List<UserFlowEntity> list= userUsageAnalysisService.queryAll();
        System.out.println(JSON.toJSON(list));
        responseEntity.setData(list);
        responseEntity.setCode(200);
        responseEntity.setMsg("success");
        try {
            object = JSON.toJSONString(responseEntity, SerializerFeature.PrettyFormat, SerializerFeature.WriteMapNullValue);
        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
        }
        System.out.println(object);
        return object;
    }
}
