package com.mh.eems.datasource;

import java.util.HashMap;
import java.util.Map;


/**
 * 
 * @ClassName:  ProjectDBMgr   
 * @Description:TODO(管理项目编码与数据库IP和名称的映射关系)   
 * @author: 铭汉科技—LJF 
 * @date:   2018年11月15日 上午10:10:21   
 *
 */
public class ProjectDBMgr {
	
	/**
     * 保存项目编码与数据名称的映射关系。这里是硬编码，实际开发中这个关系数据可以保存到redis缓存中；
     * 新增一个项目或者删除一个项目只需要更新缓存。到时这个类的接口只需要修改为从缓存拿数据。
     */
    private Map<String, String> dbNameMap = new HashMap<String, String>();
 
    /**
     * 保存项目编码与数据库IP的映射关系。
     */
    private Map<String, String> dbIPMap = new HashMap<String, String>();
 
    private ProjectDBMgr() {

		dbNameMap.put("能效管理系统", "EEMS");
//        dbIPMap.put("能效管理系统", "127.0.0.1:1433");
		dbIPMap.put("能效管理系统", "134.175.248.88:2008");
//		dbIPMap.put("能效管理系统", "192.168.1.222:2012");
//		dbIPMap.put("能效管理系统", "106.52.192.26:2012");
		
    	// 厦门双桥
//    	dbNameMap.put("NB网络电表", "XM_SHQ");
//		dbIPMap.put("NB网络电表", "120.25.220.177:9999");
    	
    	// 测试地址
//		dbNameMap.put("NB网络电表", "yjc");
//		dbIPMap.put("NB网络电表", "134.175.248.88:2008");
//		dbNameMap.put("本地NB网络电表", "yjc");
//		dbIPMap.put("本地NB网络电表", "192.168.1.222");

    }
 
    public static ProjectDBMgr instance() {
        return ProjectDBMgrBuilder.instance;
    }
 
    // 实际开发中改为从缓存获取
    public String getDBName(String projectCode) {
    	System.out.println(dbNameMap.toString());
        if (dbNameMap.containsKey(projectCode)) {
            return dbNameMap.get(projectCode);
        }
 
        return "";
    }
 
    //实际开发中改为从缓存中获取
    public String getDBIP(String projectCode) {
    	System.out.println(dbIPMap.toString());
        if (dbIPMap.containsKey(projectCode)) {
            return dbIPMap.get(projectCode);
        }
 
        return "";
    }
 
    private static class ProjectDBMgrBuilder {
        private static ProjectDBMgr instance = new ProjectDBMgr();
    }
    
}
