package com.mh.eems.job;
import com.alibaba.fastjson.JSONObject;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.DeviceInstallEntity;
import com.mh.eems.entity.GateWayManageEntity;
import com.mh.eems.entity.ReporterEntity;
import com.mh.eems.mapper.GatewayManageMapper;
import com.mh.eems.service.DeviceInstallService;
import com.mh.eems.service.StatisticsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
/**
 * @Classname SendNotification
 * @Description 每天定时发生统计报告
 * @Date 2020-07-21 09:07
 * @Created by NING MEI
 */
@Component
@EnableScheduling
public class SendNotification {
    @Autowired
    private StatisticsService statisticsService;
    @Autowired(required = false)
    GatewayManageMapper gatewayService;
    @Autowired(required = false)
    DeviceInstallService deviceInstallService;
    @Scheduled(cron = "0 30 18 * * ? ")
    public void run() {
        StringBuilder message = new StringBuilder();
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        Map<String, Object> map = new HashMap<>();
        map.put("levelId", null);
        map.put("levelName", null);
        map.put("queryType", null);
        map.put("page", 1);
        map.put("limit", 10);
        List<ReporterEntity> list = statisticsService.queryStatisticsReport(map);
        int fallNum = 0;
        int exceptionNum = 0;
//        message.append("失败统计-");
        for (int i = 0; i < list.size(); i++) {
            ReporterEntity entity = list.get(i);
            fallNum += Integer.parseInt(entity.getFailNum());
            exceptionNum += Integer.parseInt(entity.getExceptionNum());
        }
        message.append("水表失败：" + fallNum + "个，");
        message.append("水表异常：" + exceptionNum + "个，");
        message.append("");
        GateWayManageEntity gm = new GateWayManageEntity();
        gm.setStatus(0);
        List<GateWayManageEntity> gme = gatewayService.queryGatewayByOther(gm, 1, 10, null, null);
        message.append("网关离线：" + gme.size() + "个，");
        gm.setStatus(2);
        gme = gatewayService.queryGatewayByOther(gm, 1, 10, null, null);
        message.append("网关异常：" + gme.size() + "个。");
        //System.out.println(message.toString());
        getJson(message.toString(),"18922383731");
//        getJson(message.toString(),"13242849644");
        DeviceInstallEntity deviceInstallEntity = new DeviceInstallEntity();
        deviceInstallEntity.setParamName("NB水表");
        deviceInstallEntity.setStatus("抄表异常");
        deviceInstallEntity.setLastValue(1.0);
        int size = deviceInstallService.queryCount(deviceInstallEntity, "", "");
        if (size >300) {
            getJson("NB水表异常："+size+"个","15277338501");
            getJson("NB水表异常："+size+"个","15278773313");
        }
        System.out.println(size);
    }
    public void getJson(String message,String tel) {
        JSONObject json = new JSONObject();
        JSONObject first = new JSONObject();
        JSONObject keyword1 = new JSONObject();
        JSONObject keyword2 = new JSONObject();
        JSONObject keyword3 = new JSONObject();
        JSONObject remark = new JSONObject();
        //String tel = "15278773313";
        String templateId = "EVR8yltNBbYtqsxpZt7CnRvuEt-IENRZz02puAbe18E";
        MultiValueMap<String, Object> map = new LinkedMultiValueMap<>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        first.put("value", "每日统计报表");
        first.put("color", "#173177");
        json.put("first", first);
        keyword1.put("value", "网关水表异常统计");
        keyword1.put("color", "#173177");
        json.put("keyword1", keyword1);
        keyword2.put("value", sdf.format(new Date()));
        keyword2.put("color", "#173177");
        json.put("keyword2", keyword2);
        keyword3.put("value", "自动运算");
        keyword3.put("color", "#173177");
        json.put("keyword3", keyword3);
        remark.put("value", message);
        json.put("remark", remark);
        map.add("key", "minghan2020");
        map.add("tel", tel);
        map.add("tplid", templateId);
        map.add("data", json.toJSONString());
        push(map);
    }
    /**
     * 消息推送
     * @param data
     */
    public void push(MultiValueMap<String, Object> data) {
        RestTemplate rest = new RestTemplate();
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
        HttpEntity<MultiValueMap<String, Object>> request = new HttpEntity<>(data, headers);
        ResponseEntity<String> response = rest.postForEntity("http://wushuhe.w.ratuo.com.cn/api/index/SendNotifyMessage", request, String.class);
        System.out.println(response);
    }
}
