package com.mh.eems.job;

import com.alibaba.fastjson.JSON;
import com.mh.eems.controller.ReporterController;
import com.mh.eems.entity.ReporterEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.mapper.WaterStatusDayMapper;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;

/**
 * @Classname UpdateWaterStatusDay
 * @Description 定时每天存储水表状态
 * @Date 2020-07-21 09:07
 * @Created by NING MEI
 */
@Component
@EnableScheduling
public class UpdateWaterStatusDay {
    @Resource
    ReporterController reporterController;
    @Resource
    WaterStatusDayMapper waterStatusDayMapper;

    @Scheduled(cron = "0 55 23 * * ? ")
    public void run() {
        Object object = reporterController.queryStatisticsReportByOther(null, null, null, 1, 10);
        List<ReporterEntity> list = JSON.parseObject(object.toString(), ResponseEntity.class).getData();
        int n = waterStatusDayMapper.insertWaterSratusDay(list);
        if (n >0) {
            System.out.println("更新水表状态统计成功！");
        }else {
            System.out.println("更新水表状态统计失败！");
        }

    }
}
