package com.mh.eems.job;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.service.DeviceInstallService;
import com.mh.eems.util.SpringUtil;

/**
 * 
 * @ClassName:  UpdatedStatusJob   
 * @Description:TODO(添加定时任务)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年9月12日 上午11:43:40   
 *
 */
@Component
public class UpdatedStatusJob {
	
	private static final Logger logger = LoggerFactory.getLogger(UpdatedStatusJob.class); 
	
	@Scheduled(cron = "0 0/59 * * * ? ")
	public void updateStatus() {
		// TODO Auto-generated method stub
		logger.info(">>>>>>>>>>>>>>>--------每59分钟定时更新一次水表状态");
		try {
			logger.info("每59分钟定时更新一次水表状态");
			DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
			DeviceInstallService deviceDataService = SpringUtil.getBean(DeviceInstallService.class);
			deviceDataService.updateDeviceGateway();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
