package com.mh.eems.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.mapping.StatementType;

import com.mh.eems.entity.DValueEntity;

/**
 * 
 * @ClassName:  DValueMapper   
 * @Description:TODO(总分差mapper类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月14日 下午1:58:21   
 *
 */
@Mapper
public interface DValueMapper {
	
	// 根据时间、查询类型（hour/day/year）、楼盘/区域/楼栋查询出总分差值 status // 0：没有合计；1：添加合计
	@Select({ "exec pro_d_value #{startTime,mode=IN,jdbcType=VARCHAR},"
			+ "#{endTime,mode=IN,jdbcType=VARCHAR},"
			+ "#{queryType,mode=IN,jdbcType=VARCHAR},"
			+ "#{nodeName,mode=IN,jdbcType=VARCHAR},"
			+ "#{level,mode=IN,jdbcType=INTEGER},"
			+ "#{page,mode=IN,jdbcType=INTEGER},"					
			+ "#{limit,mode=IN,jdbcType=INTEGER},"
			+ "#{status,mode=IN,jdbcType=INTEGER},"	
			+ "#{result_count,mode=OUT,jdbcType=INTEGER}" })
	@Results({ @Result(property = "id", column = "id"),
		@Result(property = "houseNum", column = "house_num"),
		@Result(property = "houseAddress", column = "house_address"),
		@Result(property = "lastTime", column = "last_date"),
		@Result(property = "lastFlow", column = "last_flow"),
		@Result(property = "curTime", column = "cur_date"),
		@Result(property = "curFlow", column = "cur_flow"),
		@Result(property = "calcFlow", column = "calc_flow"),
		@Result(property = "branchUsed", column = "branch_used"),
		@Result(property = "dValue", column = "d_value"),
		@Result(property = "name", column = "building_name")
	})
	@Options(statementType=StatementType.CALLABLE)
	List<DValueEntity> queryDValue(Map<String, Object> map);

}
