package com.mh.eems.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.UpdateProvider;

import com.mh.eems.entity.DeviceParamEntity;
import com.mh.eems.provider.DeviceParamProvider;

/**
 * 
 * @ClassName:  DeviceParamMapper   
 * @Description:TODO(设备参数管理)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年7月30日 下午5:03:57   
 *
 */
@Mapper
public interface DeviceParamMapper {
	
	// 查询记录数
	@SelectProvider(type = DeviceParamProvider.class, method = "queryDeviceParamsByOthersCount")
	int queryDeviceParamsCount(@Param("dp") DeviceParamEntity dp, @Param("page") int page, @Param("limit") int limit);
	
	// 查询全部
//	@Select("select * from device_parameter order by id desc "
//			+ "offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY")
//	@Results({ @Result(property = "paramId", column = "param_id"),
//		@Result(property = "paramName", column = "param_name"),
//		@Result(property = "paramBaudrate", column = "param_baudrate")
//	})
//	List<DeviceParamEntity> queryAllDeviceParams(@Param("page") int page, @Param("limit") int limit);
	
	// 根据条件查询
	@SelectProvider(type = DeviceParamProvider.class, method = "queryDeviceParamsByOthers")
	@Results({ @Result(property = "paramId", column = "param_id"),
			@Result(property = "paramName", column = "param_name"),
			@Result(property = "paramBaudrate", column = "param_baudrate") })
	List<DeviceParamEntity> queryDeviceParamsByOthers(@Param("dp") DeviceParamEntity dp, @Param("page") int page,
			@Param("limit") int limit);
	
	
	// 根据条件ID查询是否有重复记录
	@SelectProvider(type = DeviceParamProvider.class, method = "queryDeviceParamsById")
	@Results({ @Result(property = "paramId", column = "param_id"),
			@Result(property = "paramName", column = "param_name"),
			@Result(property = "paramBaudrate", column = "param_baudrate") })
	DeviceParamEntity queryDeviceParamsById(@Param("dp") DeviceParamEntity dp);
	
	// 添加记录,并返回id值
	@Options(useGeneratedKeys = true, keyProperty = "id", keyColumn = "id")
	@Insert("insert into device_parameter(param_id,param_name,param_baudrate) values ("
			+ "#{paramId},#{paramName},#{paramBaudrate})")
	int insertDeviceParam(DeviceParamEntity deviceParamEntity);
	
	// 删除记录
	@Delete("delete from device_parameter where param_id = #{paramId}")
	int deleteDeviceParamById(DeviceParamEntity deviceParamEntity);
	
	// 更新记录
	@UpdateProvider(type = DeviceParamProvider.class, method = "updateDeviceParam")
	int updateDeviceParam(DeviceParamEntity deviceParamEntity);
	
	
}
