package com.mh.eems.mapper;

import java.util.List;

import com.mh.eems.provider.GatewayManageProvider;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.mapping.StatementType;

import com.mh.eems.dto.ResultDto;
import com.mh.eems.entity.HistoryByHandEntity;
import com.mh.eems.provider.HistoryProvider;

/**
 * 
 * @ClassName:  HistoryByHandMapper   
 * @Description:TODO(手抄表记录Mapper)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月8日 上午9:16:43   
 *
 */
@Mapper
public interface HistoryByHandMapper {

	// 通过excel批量导入数据库
	@InsertProvider(type = HistoryProvider.class, method = "batchInsertByExcel")
	int historyByHandServiceBatchInsert(List<Object> excelhistoryByHandServiceInstallEntities);
	
	// 查询记录值
	@Select("select * from wt_history_hand order by cur_date desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY")
	@Results({ 
		@Result(property = "id", column = "id"),
		@Result(property = "houseNum", column = "house_num"),
		@Result(property = "deviceNum", column = "device_num"),
		@Result(property = "collectionNum", column = "collection_num"),
		@Result(property = "curFlow", column = "cur_flow"),
		@Result(property = "curDate", column = "cur_date"),
		@Result(property = "grade", column = "grade")
	})
	List<HistoryByHandEntity> queryHistorys(@Param("page") int page, @Param("limit") int limit);
	
	// 查询记录数
	@Select("select top 1 count(*) from wt_history_hand")
	int queryHistoryCount();
	
	// 添加记录值,执行存储过程插入值，顺便计算使用量
	@Select({ "exec pro_deal_hitory_hand "
			+"#{h.id,mode=IN,jdbcType=INTEGER},"
			+ "#{h.houseNum,mode=IN,jdbcType=VARCHAR},"
			+ "#{h.deviceNum,mode=IN,jdbcType=VARCHAR},"
			+ "#{h.collectionNum,mode=IN,jdbcType=VARCHAR},"
			+ "#{h.curFlow,mode=IN,jdbcType=VARCHAR},"
			+ "#{h.curDate,mode=IN,jdbcType=VARCHAR},"
			+ "#{code,mode=IN,jdbcType=INTEGER}"
			})
	@Results({@Result(property = "result",column = "result")})
	@Options(statementType=StatementType.CALLABLE)
	ResultDto insertHistory(@Param("h")HistoryByHandEntity historyByHandEntity,@Param("code") int code);
	
	// 修改记录值
	@UpdateProvider(type = HistoryProvider.class, method = "updateHistory")
	int updateHistory(HistoryByHandEntity historyByHandEntity);
	
	// 删除记录值
	@Delete("delete from wt_history_hand where id = #{id}")
	int deleteHistory(@Param("id") int id);
	
	// 查询当前户号的最新读数
	@Select("select top 1 * from device_install where house_num = #{houseNum}")
	@Results({@Result(property = "curFlow", column = "last_value")})
	HistoryByHandEntity queryLastValue(HistoryByHandEntity historyByHandEntity);

//	@Insert("insert into wt_histoty_hand(house_num,device_num,collection_num,cur_flow,cur_date,grade) values("
//			+ "#{houseNum},"
//			+ "#{deviceNum},"
//			+ "#{collectionNum},"
//			+ "#{curFlow},"
//			+ "#{curDate},"
//			+ "1"
//			+ ")")
//	int insertHistory(HistoryByHandEntity historyByHandEntity);
	

}
