package com.mh.eems.mapper;

import com.mh.eems.entity.MasterWaterEntity;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

/**
 * @Classname MasterWaterMapper
 * @Description 总水表
 * @Date 2020-07-15 17:13
 * @Created by NING MEI
 */
@Mapper
public interface MasterWaterMapper {
    @Results({
            @Result(property = "dayFlow",column = "day_flow"),
            @Result(property = "name",column = "name"),
            @Result(property = "waterId",column = "water_id"),
            @Result(property = "updateTime",column = "update_time"),
            @Result(property = "justFlow",column = "just_flow"),
            @Result(property = "netFlow",column = "net_flow"),
            @Result(property = "backFlow",column = "back_flow"),
            @Result(property = "hourFlow",column = "hour_flow"),
            @Result(property = "kpa",column = "kpa"),
            @Result(property = "mAH",column = "mAH"),
            @Result(property = "supplyVoltage",column = "supply_voltage"),
            @Result(property = "supplyCurrent",column = "supply_current"),
            @Result(property = "longitude",column = "longitude"),
            @Result(property = "latitude",column = "latitude"),
            @Result(property = "mAHSos",column = "mah_sos"),
            @Result(property = "cavityTemp",column = "cavity_temp"),
            @Result(property = "errorCode",column = "error_code"),
            @Result(property = "measureCode",column = "measure_code"),
            @Result(property = "measureVer",column = "measure_ver"),
            @Result(property = "displayCode",column = "display_code"),
            @Result(property = "displayVer",column = "display_ver"),
            @Result(property = "dataAddressBlock",column = "data_address_block"),
            @Result(property = "measureDisplay",column = "measure_display"),
            @Result(property = "remark",column = "remark"),
            @Result(property = "wifiSignal",column = "wifi_signal"),
            @Result(property = "electrodeWiFi",column = "electrode_wifi"),
            @Result(property = "atcValue",column = "atc_value"),
            @Result(property = "electrodState",column = "electrod_state"),
            @Result(property = "dataAddress",column = "data_address"),
            @Result(property = "stationId",column = "station_id"),
            @Result(property = "processSos",column = "process_sos"),
            @Result(property = "caliber",column = "caliber"),
            @Result(property = "converterId",column = "converter_id"),
            @Result(property = "lastTime",column = "last_time"),
            @Result(property = "communicationLog",column = "communication_log"),
            @Result(property = "CRC",column = "crc"),
    })
    @Select("select b.house_address'name',C.calc_flow'day_flow',a.* from (select * from (select *,row_number() over ( partition by water_id order by update_time desc ) rn from master_water )as s where s.rn=1) a left join user_manage b on a.water_id=b.collection_num left join wt_day${tableName} c on a.water_id=c.house_num where convert(varchar(10),c.cur_date,120) =convert(varchar(10),getdate(),120) order by update_time desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY")
    List<MasterWaterEntity> queryAll(Map<String,Object> map);
    @Select("(select count(*) from (select *,row_number() over ( partition by water_id order by update_time desc ) rn from master_water )as s where s.rn=1)")
    int queryCount();
}

