package com.mh.eems.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.mapping.StatementType;

import com.mh.eems.entity.PeakValleyEntity;

/**
 * 
 * @ClassName:  PeakValleyMapper   
 * @Description:TODO(峰谷值查询Mapper类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月12日 上午8:36:26   
 *
 */
public interface PeakValleyMapper {
	
	// 查询一天24小时的用量值
	@Select({ "exec [pro_peak_valley] "
			+ "#{code,mode=IN,jdbcType=INTEGER},"
			+ "#{name,mode=IN,jdbcType=VARCHAR},"
			+ "#{cur_date,mode=IN,jdbcType=VARCHAR},"
			+ "#{page,mode=IN,jdbcType=INTEGER},"
			+ "#{limit,mode=IN,jdbcType=INTEGER},"
			+ "#{count,mode=IN,jdbcType=INTEGER} " })
	@Results({ @Result(property = "id", column = "id"),
		@Result(property = "name", column = "name"),
		@Result(property = "calcFlow", column = "calc_flow"),
		@Result(property = "curTime", column = "cur_date"),
		@Result(property = "mark", column = "mark")
	})
	@Options(statementType=StatementType.CALLABLE)
	List<PeakValleyEntity> queryPeakValley(@Param("code") Integer code,@Param("name")String name,@Param("curDate")String curDate,
			@Param("page") Integer page,@Param("limit") Integer limit,@Param("count")Integer count);

	// 查询一天24小时的用量值和总记录数
	@Select({ "exec pro_peak_valley #{code,mode=IN,jdbcType=INTEGER},"
			+ "#{name,mode=IN,jdbcType=VARCHAR},"
			+ "#{cur_date,mode=IN,jdbcType=VARCHAR},"
			+ "#{page,mode=IN,jdbcType=INTEGER},"
			+ "#{limit,mode=IN,jdbcType=INTEGER},"
			+ "#{result_count,mode=OUT,jdbcType=INTEGER} " })
	@Results({ @Result(property = "id", column = "id"),
		@Result(property = "name", column = "name"),
		@Result(property = "calcFlow", column = "calc_flow"),
		@Result(property = "curTime", column = "cur_date"),
		@Result(property = "mark", column = "mark")
	})
	@Options(statementType=StatementType.CALLABLE)
	List<PeakValleyEntity> queryPeakValleyByMap(Map<String, Object> map);
	
	// 查询中条数
	@Select({ "exec pro_peak_valley #{code,mode=IN,jdbcType=INTEGER},"
			+ "#{name,mode=IN,jdbcType=VARCHAR},"
			+ "#{cur_date,mode=IN,jdbcType=VARCHAR},"
			+ "#{page,mode=IN,jdbcType=INTEGER},"
			+ "#{limit,mode=IN,jdbcType=INTEGER},"
			+ "#{count,mode=IN,jdbcType=INTEGER} " })
	@Options(statementType=StatementType.CALLABLE)
	int queryPeakValleyCount(@Param("code") Integer code,@Param("name")String name,@Param("cur_date")String curDate,
			@Param("page") Integer page,@Param("limit") Integer limit,@Param("count")Integer count);
	

}
