package com.mh.eems.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.mapping.StatementType;

import com.mh.eems.entity.ReporterEntity;

/**
 * 
 * @ClassName:  StatisticsMapper   
 * @Description:TODO(统计报表mapper接口类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年11月1日 下午2:03:17   
 *
 */
@Mapper
public interface StatisticsMapper {
	
	// 查询一天24小时的用量值和总记录数
	@Select({ "exec pro_statistics_report #{levelId,mode=IN,jdbcType=INTEGER},"
			+ "#{levelName,mode=IN,jdbcType=VARCHAR},"
			+ "#{queryType,mode=IN,jdbcType=VARCHAR},"
			+ "#{page,mode=IN,jdbcType=INTEGER},"
			+ "#{limit,mode=IN,jdbcType=INTEGER},"
			+ "#{result_count,mode=OUT,jdbcType=INTEGER} " })
	@Results({ @Result(property = "areaName", column = "area_name"),
		@Result(property = "totalNum", column = "total_num"),
		@Result(property = "successNum", column = "success_num"),
		@Result(property = "exceptionNum", column = "exception_num"),
		@Result(property = "failNum", column = "fail_num"),
		@Result(property = "curTime", column = "cur_time")
	})
	@Options(statementType=StatementType.CALLABLE)
	List<ReporterEntity> queryStatisticsReport(Map<String, Object> map);

}
