package com.mh.eems.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.UpdateProvider;

import com.mh.eems.entity.SysLogEntity;
import com.mh.eems.provider.SysLogProvider;
import com.mh.eems.provider.SysUserProvider;

/**
 * 
 * @ClassName:  LogMapper   
 * @Description:TODO(日志mapper)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年7月29日 上午10:11:53   
 *
 */
@Mapper
public interface SysLogMapper {
	
	// 添加日志 返回主键ID
	@Options(useGeneratedKeys = true, keyProperty = "id", keyColumn = "id")
	@Insert("insert into sys_logs(user_id,user_name,module,type,logs,log_date,remark,grade)"
			+ "values(#{userId},#{userName},#{module},#{type},#{logs},getdate(),#{remark},#{grade})")
//	@Insert("insert into sys_logs(user_id,user_name)"
//			+ "values(1,'test')")
	int insertLogs(SysLogEntity sysLogEntity);
	
	@SelectProvider(type = SysLogProvider.class, method = "querySysLogs")
	@Results({ @Result(property = "id", column = "id"),
		@Result(property = "userId", column = "user_id"),
		@Result(property = "userName", column = "user_name"),
		@Result(property = "module", column = "module"),
		@Result(property = "type", column = "type"),
		@Result(property = "logs", column = "logs"),
		@Result(property = "logDate", column = "log_date"),
		@Result(property = "remark", column = "remark"),
		@Result(property = "grade", column = "grade")})
	List<SysLogEntity> querySysLogs(@Param("startTime") String startTime, 
									@Param("endTime") String endTime, 
									@Param("opType") String opType, 
									@Param("userName") String userName, 
									@Param("page") int page, 
									@Param("limit") int limit);
	
	@SelectProvider(type = SysLogProvider.class, method = "querySysLogsCount")
	int querySysLogsCount(@Param("startTime") String startTime, 
									@Param("endTime") String endTime, 
									@Param("opType") String opType, 
									@Param("userName") String userName, 
									@Param("page") int page, 
									@Param("limit") int limit);

}
