package com.mh.eems.mapper;

import java.util.List;
import java.util.Map;

import com.mh.eems.entity.UsageAnalysisEntity2;
import com.mh.eems.provider.UserProvider;
import com.mh.eems.provider.UserProvider2;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.mapping.StatementType;

import com.mh.eems.entity.UsageAnalysisEntity;

@Mapper
public interface UsageAnalysisMapper {

    // 查询一天24小时的用量值和总记录数
    @Select({"exec pro_usage_analysis #{level,mode=IN,jdbcType=INTEGER},"
            + "#{nodeName,mode=IN,jdbcType=VARCHAR},"
            + "#{time,mode=IN,jdbcType=VARCHAR},"
            + "#{page,mode=IN,jdbcType=INTEGER},"
            + "#{limit,mode=IN,jdbcType=INTEGER},"
            + "#{result_count,mode=OUT,jdbcType=INTEGER} "})
    @Results({@Result(property = "id", column = "id"),
            @Result(property = "time", column = "times"),
            @Result(property = "totalUsed", column = "total_used"),
            @Result(property = "ratio", column = "ratio")
    })
    @Options(statementType = StatementType.CALLABLE)
    List<UsageAnalysisEntity> queryUsageAnalysisByMap(Map<String, Object> map);

    @SelectProvider(type = UserProvider2.class, method = "queryUsersByOtheredMap")
    @Results({@Result(property = "id", column = "id"),
            @Result(property = "name", column = "name"),
            @Result(property = "time", column = "time"),
            @Result(property = "totalUsed", column = "totalUsed")
    })
    List<UsageAnalysisEntity> queryUsageAnalysisByMap2(Map<String, Object> map);

//    @SelectProvider(type = UserProvider.class, method = "queryUsersByOtheredMap3")
//    @Results({@Result(property = "id", column = "id"),
//            @Result(property = "name", column = "name"),
//            @Result(property = "time", column = "time"),
//            @Result(property = "totalUsed", column = "totalUsed")
//    })
//    List<UsageAnalysisEntity2> queryUsageAnalysisByMap3(Map<String, Object> map);

}
