package com.mh.eems.mapper;

import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.mapping.StatementType;

import com.mh.eems.entity.NowUsageEntity;
import com.mh.eems.entity.UsageEntity;

/**
 * 用量查询
 * @author chison
 *
 */
@Mapper
public interface UsageMapper {

	//查询所有用量信息
	@Select({"exec pro_usage "
			+ "#{TimeType,mode=IN,jdbcType=VARCHAR},"
			+ "#{houseNum,mode=IN,jdbcType=VARCHAR},"
			+ "#{houseAddress,mode=IN,jdbcType=VARCHAR},"
			+ "#{starTime,mode=IN,jdbcType=VARCHAR},"
			+ "#{endTime,mode=IN,jdbcType=VARCHAR},"
			+ "#{resultCount,mode=OUT,jdbcType=INTEGER},"
			+ "#{page,mode=IN,jdbcType=INTEGER},"
			+ "#{limit,mode=IN,jdbcType=INTEGER},"
			+ "#{areaName,mode=IN,jdbcType=VARCHAR},"
			+ "#{level,mode=IN,jdbcType=INTEGER}"})
	@Results({@Result(property = "houseNum", column = "house_num"),
		@Result(property = "houseAddress", column = "house_address"),
		@Result(property = "deviceNum", column = "wt_num"),
		@Result(property = "lastFlow", column = "last_flow"),
		@Result(property = "curFlow", column = "cur_flow"),
		@Result(property = "curDate", column = "cur_date"),
		@Result(property = "total", column = "resultCount"),
		@Result(property = "lastDate", column = "last_date"),
		@Result(property = "calcFlow", column = "calc_flow"),
		@Result(property = "meterState", column = "meterState")})
	@Options(statementType=StatementType.CALLABLE)
	List<UsageEntity> queryAllUsage(Map<String, Object> map);
	
	@Select("select sum(t.calc_flow)as calc_flow,u.house_num as nodeName from (select t.*,u.parent_id as pid2,u.house_num as nodeName2 from (select t.*,u.parent_id as pid1,u.house_num as nodeName1 from (select w.calc_flow,w.house_num,u.parent_id,w.cur_date from ${tableName} w left join user_manage u on w.house_num=u.house_num where CONVERT(varchar(10),cur_date,121)=#{time})t left join user_manage u on t.parent_id=u.id)t left join user_manage u on t.pid1=u.id)t left join user_manage u on t.pid2=u.id group by u.house_num ")
	@Results({@Result(property = "calcFlow",column = "calc_flow"),
		@Result(property = "houseNum",column="nodeName")})
	List<UsageEntity> usageCount(@Param("time") String time,@Param("tableName")String tableName);
	
	//查询片区名称
	@Select("select house_num from user_manage where parent_id=1")
	List<String> queryArea();
	
	/**查询实时用量*/
	@Select({"exec pro_now_date "
			+ "#{level_name,mode=IN,jdbcType=VARCHAR},"
			+ "#{level_id,mode=IN,jdbcType=INTEGER},"
			+ "#{house_num,mode=IN,jdbcType=VARCHAR},"
			+ "#{page,mode=IN,jdbcType=INTEGER},"
			+ "#{limit,mode=IN,jdbcType=INTEGER},"
			+ "#{status,mode=IN,jdbcType=INTEGER},"
			+ "#{count,mode=OUT,jdbcType=INTEGER}"})
	@Results({@Result(property = "areaName",column = "nodeName"),
		@Result(property = "houseNum",column = "houseNum"),
		@Result(property = "houseAddress",column = "houseAddress"),
		@Result(property = "curFlow",column = "curFlow"),
		@Result(property = "curDate",column = "curDate"),
		@Result(property = "count",column = "count")})
	@Options(statementType=StatementType.CALLABLE)
	List<NowUsageEntity> nowUsage(Map<String, Object> map);
}
