package com.mh.eems.mapper;

import com.mh.eems.entity.UserFlowEntity;
import com.mh.eems.provider.UserProvider2;
import org.apache.ibatis.annotations.*;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Classname UserUsageAnalysisMapper
 * @Description TODO
 * @Date 2020-06-22 16:43
 * @Created by NING MEI
 */
@Mapper
public interface UserUsageAnalysisMapper {

    @Results({
            @Result(property = "nowValue",column = "now_value"),
            @Result(property = "houseNum",column = "house_num"),
            @Result(property = "flowTime",column = "flow_time"),
            @Result(property = "totalValue",column = "total_value"),
            @Result(property = "monthValue",column = "month_Value"),
            @Result(property = "flow",column = "flow"),
            @Result(property = "lastFlow",column = "last_flow"),
            @Result(property = "dayFlow",column = "day_flow"),
            @Result(property = "lastDayFlow",column = "last_day_flow"),
            @Result(property = "yearFlow",column = "year_flow"),
            @Result(property = "lastYearFlow",column = "last_year_flow"),
            @Result(property = "dayZero",column = "day_zero"),
            @Result(property = "monthZero",column = "month_zero"),
            @Result(property = "exceptionCount",column = "exception_count"),
            @Result(property = "abnormaCount",column = "abnorma_count")
    })
    @SelectProvider(type = UserProvider2.class ,method ="queryUserUsageAnalysisByOtheredMap")
    List<UserFlowEntity> queryByType(Map<String,Object>map);
    @Select("select * FROM user_flow ")
    List<UserFlowEntity> test();
    @Select("select count(*) FROM user_flow")
    int queryCount();

    @Results({
            @Result(property = "nowValue",column = "now_value"),
            @Result(property = "houseNum",column = "house_num"),
            @Result(property = "flowTime",column = "flow_time"),
            @Result(property = "totalValue",column = "total_value"),
            @Result(property = "monthValue",column = "last_Value"),
            @Result(property = "flow",column = "flow"),
            @Result(property = "lastFlow",column = "last_flow"),
            @Result(property = "dayFlow",column = "day_flow"),
            @Result(property = "lastDayFlow",column = "last_day_flow"),
            @Result(property = "yearFlow",column = "year_flow"),
            @Result(property = "lastYearFlow",column = "last_year_flow"),
            @Result(property = "dayZero",column = "day_zero"),
            @Result(property = "monthZero",column = "month_zero"),
            @Result(property = "exceptionCount",column = "exception_count"),
            @Result(property = "abnormaCount",column = "abnorma_count"),
            @Result(property = "houseNum",column = "house_num"),
            @Result(property = "houseAddress",column = "house_address"),
            @Result(property = "buildingName",column = "building_name"),
            @Result(property = "collectionNum",column = "collection_num"),
            @Result(property = "dataCom",column = "data_com"),
            @Result(property = "paramName",column = "param_name"),
            @Result(property = "status",column = "grade"),
    })
    @Select("select a.now_value, a.id,a.house_num,convert(varchar(10),a.flow_time,120)'flow_time',a.total_value,a.last_value'monthValue',a.flow,a.last_flow,a.day_flow,a.last_day_flow,a.year_flow,a.last_year_flow,a.day_zero,a.month_zero,a.exception_count,a.abnorma_count,b.house_address,b.building_name,b.collection_num,b.data_com ,b.param_name ,b.grade from user_flow a left join device_install b on a.house_num=b.house_num")
    List<UserFlowEntity> queryAll();
}
