package com.mh.eems.provider;

import java.text.MessageFormat;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.jdbc.SQL;

import com.mh.eems.entity.DeviceInstallEntity;
import com.mh.eems.entity.Excel2DeviceInstallEntity;

/**
 * @ClassName: DeviceInstallProvider
 * @Description:TODO(动态拼接SQL语句)
 * @author: 铭汉科技—LJF
 * @date: 2019年8月6日 下午3:06:25
 */
public class DeviceInstallProvider {

    /* 批量插入 */
    @SuppressWarnings("unchecked")
    public String batchInsertByExcel(Map<?, ?> map) {

        List<Excel2DeviceInstallEntity> deviceInstallEntities = (List<Excel2DeviceInstallEntity>) map.get("list");
        StringBuilder sb = new StringBuilder();
        sb.append("insert into device_install " +
                "(house_num,house_address,building_id,building_name,device_num,collection_num,initial_value,param_id,param_name,"
                + "device_caliber,communication_type,create_time,device_type,data_com) values ");
        MessageFormat mf = new MessageFormat(
                "(#'{'list[{0}].houseNum}, "
                        + "#'{'list[{0}].houseAddress}, "
                        + "(select top 1 id from user_manage where house_num = #'{'list[{0}].buildingName}), "
                        + "#'{'list[{0}].buildingName}, "
                        + "#'{'list[{0}].deviceNum}, "
                        + "#'{'list[{0}].collectionNum}, "
                        + "#'{'list[{0}].initialValue}, "
                        + "(select top 1 param_id from device_parameter where param_name = #'{'list[{0}].paramName}), "
                        + "#'{'list[{0}].paramName}, "
                        + "#'{'list[{0}].deviceCaliber}, "
                        + "#'{'list[{0}].communicationType}, "
                        + "getdate(), "
                        + "#'{'list[{0}].deviceType}, "
                        + "#'{'list[{0}].dataPort})");

        for (int i = 0; i < deviceInstallEntities.size(); i++) {
            sb.append(mf.format(new Object[]{i}));
            if (i < deviceInstallEntities.size() - 1)
                sb.append(",");
        }
        return sb.toString();
    }

    // 查询记录总数
    public String queryCount(final DeviceInstallEntity dInstallEntity, String startTime, String endTime) {
        StringBuffer sql = new StringBuffer("select top 1 count(*) from device_install where 1 = 1 ");
        if (startTime != null && startTime != "") {
            sql.append(" and convert(varchar(10),create_time,23)>=#{startTime}");
        }
        if (endTime != null && startTime != "") {
            sql.append(" and convert(varchar(10),create_time,23)<=#{endTime}");
        }

        if (dInstallEntity.getHouseNum() != null) {
            sql.append(" and house_num = #{dInstallEntity.houseNum}");
        }

        if (dInstallEntity.getBuildingName() != null) {
            sql.append(" and building_name like concat('%',#{dInstallEntity.buildingName},'%')");
        }
        if (dInstallEntity.getDeviceNum() != null) {
            sql.append(" and device_num like concat('%',#{dInstallEntity.deviceNum},'%')");
        }
        if (dInstallEntity.getParamName() != null) {
            sql.append(" and param_name like concat('%',#{dInstallEntity.paramName},'%')");
        }
        if (dInstallEntity.getCommunicationType() != null) {
            sql.append(" and communication_type like concat('%',#{dInstallEntity.communicationType},'%')");
        }
        if (dInstallEntity.getDeviceCaliber() != null) {
            sql.append(" and device_caliber like concat('%',#{dInstallEntity.deviceCaliber},'%')");
        }
        if (dInstallEntity.getDataCom() != null) {
            sql.append(" and data_com like concat('%',#{dInstallEntity.dataCom},'%')");
        }
        if (dInstallEntity.getLastDate() != null && dInstallEntity.getLastDate() != "") {
            sql.append("  and convert(varchar(10),last_date,23)<= #{dInstallEntity.lastDate}");
        }
        System.out.println("设备类型：" + dInstallEntity.getDeviceType());
        if (dInstallEntity.getDeviceType() != null && dInstallEntity.getDeviceType() != "") {
            sql.append(" and device_type like concat('%',#{dInstallEntity.deviceType},'%')");
        }
        if (dInstallEntity.getStatus() != null && dInstallEntity.getStatus() != "") {
            sql.append(" and grade = #{dInstallEntity.status} ");
        }
        if (dInstallEntity.getLastValue() != 1.0 ) {
            sql.append(" and   last_value   is   null ");
        }
        //
        System.out.println(sql.toString());
        return sql.toString();
    }

    // 通过条件查询基表信息
    public String queryByType(final DeviceInstallEntity dInstallEntity, Integer page, Integer limit, String startTime, String endTime) {
        StringBuffer sql = new StringBuffer("select * from device_install where 1 = 1 ");
        if (startTime != null && startTime != "") {
            sql.append(" and convert(varchar(10),create_time,23)>=#{startTime}");
        }
        if (endTime != null && startTime != "") {
            sql.append(" and convert(varchar(10),create_time,23)<=#{endTime}");
        }
        if (page == null && limit == null) {
            if (dInstallEntity.getHouseNum() != null) {
                sql.append(" and house_num = #{dInstallEntity.houseNum}");
            }
        } else {
            if (dInstallEntity.getHouseNum() != null) {
                sql.append(" and house_num like concat('%',#{dInstallEntity.houseNum},'%')");
            }
        }
        if (dInstallEntity.getBuildingName() != null) {
            sql.append(" and building_name like concat('%',#{dInstallEntity.buildingName},'%')");
        }
        if (dInstallEntity.getDeviceNum() != null) {
            sql.append(" and device_num like concat('%',#{dInstallEntity.deviceNum},'%')");
        }
        if (dInstallEntity.getParamName() != null) {
            sql.append(" and param_name like concat('%',#{dInstallEntity.paramName},'%')");
        }
        if (dInstallEntity.getCommunicationType() != null) {
            sql.append(" and communication_type like concat('%',#{dInstallEntity.communicationType},'%')");
        }
        if (dInstallEntity.getDeviceCaliber() != null) {
            sql.append(" and device_caliber like concat('%',#{dInstallEntity.deviceCaliber},'%')");
        }
        if (dInstallEntity.getDataCom() != null) {
            sql.append(" and data_com like concat('%',#{dInstallEntity.dataCom},'%')");
        }
        if (dInstallEntity.getLastDate() != null && dInstallEntity.getLastDate() != "") {
            sql.append("  and convert(varchar(10),last_date,23)<= #{dInstallEntity.lastDate}");
        }
        System.out.println("设备类型：" + dInstallEntity.getDeviceType());
        if (dInstallEntity.getDeviceType() != null && dInstallEntity.getDeviceType() != "") {
            sql.append(" and device_type like concat('%',#{dInstallEntity.deviceType},'%')");
        }
        if (dInstallEntity.getStatus() != null && dInstallEntity.getStatus() != "") {
            sql.append(" and grade = #{dInstallEntity.status} ");
        }
        if (dInstallEntity.getLastValue() != 1.0 ) {
            sql.append(" and   last_value   is   null ");
        }
        //
        //sql.append(" and   DATEDIFF(DAY,CONVERT(VARCHAR(10),last_date,23),CONVERT(VARCHAR(10),getdate(),23))>10 ");
        if ((page != null) && (limit != null)) {
            sql.append(" order by id desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY ");
        }

        System.out.println(sql.toString());
        return sql.toString();
    }

    /**
     * 修改设备信息：安装位置、上一级名称ID、上一级名称、表身码、抄表码、初始值、设备ID、设备参数名称、口径、通讯方式、备注
     * 2019-12-18:添加lastvalue值的更新
     *
     * @param dInstallEntity
     * @return
     */
    public String updateInstall(final DeviceInstallEntity dInstallEntity) {
        String sqlString =
                new SQL() {
                    {
                        UPDATE("device_install");
                        if (dInstallEntity.getHouseAddress() != null) {
                            SET("house_address = #{houseAddress}");
                        }
                        if (dInstallEntity.getBuildingId() != null) {
                            SET("building_id = #{buildingId}");
                        }
                        if (dInstallEntity.getBuildingName() != null) {
                            SET("building_name = #{buildingName}");
                        }
                        if (dInstallEntity.getDeviceNum() != null) {
                            SET("device_num = #{deviceNum}");
                        }
                        if (dInstallEntity.getCollectionNum() != null) {
                            SET("collection_num = #{collectionNum}");
                        }
                        if (dInstallEntity.getInitialValue() != null) {
                            SET("initial_value = #{initialValue}");
                        }
                        if (dInstallEntity.getLastValue() != null) {
                            SET("last_value = #{lastValue}");
                        }
                        if (dInstallEntity.getParamName() != null) {
                            SET("param_id = (select top 1 param_id from device_parameter where param_name = #{paramName})");
                        }
                        if (dInstallEntity.getParamName() != null) {
                            SET("param_name = #{paramName}");
                        }
                        if (dInstallEntity.getDeviceCaliber() != null) {
                            SET("device_caliber = #{deviceCaliber}");
                        }
                        if (dInstallEntity.getCommunicationType() != null) {
                            SET("communication_type = #{communicationType}");
                        }
                        if (dInstallEntity.getDeviceType() != null) {
                            SET("device_type = #{deviceType}");
                        }
                        if (dInstallEntity.getRemark() != null) {
                            SET("remark = #{remark}");
                        }
                        if (dInstallEntity.getDataCom() != null) {
                            SET("data_com = #{dataCom}");
                        }
                        if (dInstallEntity.getLastDate() != null) {
                            SET("last_date = #{lastDate}");
                        }
                        if (dInstallEntity.getCreateTime() != null) {
                            SET("create_time = #{createTime}");
                        }
                        WHERE("house_num=#{houseNum}");
                    }
                }.toString();
        System.out.println(sqlString);
        return sqlString;
    }

    // 满足根据户号查询出对应的楼栋名称、楼栋ID值、表身号和抄表标识码
    public String queryDeviceByHouseNum(final String houseNum) {
        StringBuffer sql = new StringBuffer("select top 1 a.*,(select house_num from user_manage as b where b.id = a.parent_id) as node_name from user_manage as a where 1 = 1 ");
        if (houseNum != null) {
            sql.append(" and house_num = #{houseNum} and node_type = 99");
        }
        System.out.println(sql.toString());
        return sql.toString();
    }

}
