package com.mh.eems.provider;

import org.apache.ibatis.jdbc.SQL;
import com.mh.eems.entity.DeviceParamEntity;

/**
 * @ClassName:  DeviceParamProvider   
 * @Description:TODO(动态添加设备参数SQL语句)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年7月30日 下午5:24:28   
 *
 */
public class DeviceParamProvider {
	
	// 按条件查询记录
	public String queryDeviceParamsByOthers(final DeviceParamEntity dp, int page, int limit){
		StringBuffer sql = new StringBuffer("select * from device_parameter where 1 = 1");
		if (dp.getParamId() != null && dp.getParamId() != 0) {
            sql.append(" and param_id = #{dp.paramId} ");
        } 
		if (dp.getParamName() != null && dp.getParamName() != "") {
            sql.append(" and param_name = #{dp.paramName} ");
        }
		if (dp.getParamBaudrate() != null ) {
            sql.append(" and param_baudrate = #{dp.paramBaudrate} ");
        }
		if ((page != 0) && (limit != 0)){
			sql.append(" order by id desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY ");
		}
		System.out.println(sql.toString());
        return sql.toString();
	}
	// 按条件查询是否有重复记录
	public String queryDeviceParamsById(final DeviceParamEntity dp){
		StringBuffer sql = new StringBuffer("select * from device_parameter where ");
		if (dp.getParamId() != null) {
            sql.append(" param_id = #{dp.paramId} ");
        } 
		System.out.println(sql.toString());
        return sql.toString();

	}
	
	// 查询记录数
	public String queryDeviceParamsByOthersCount(final DeviceParamEntity dp, int page, int limit){

		StringBuffer sql = new StringBuffer("select top 1 count(*) from device_parameter where 1 = 1");
		if (dp.getParamId() != null) {
            sql.append(" and param_id = #{dp.paramId} ");
        } 
		if (dp.getParamName() != null && dp.getParamName() != "") {
            sql.append(" and param_name = #{dp.paramName} ");
        }
		if (dp.getParamBaudrate() != null) {
            sql.append(" and param_baudrate = #{dp.paramBaudrate} ");
        }
		System.out.println(sql.toString());
        return sql.toString();

	}
	
	// 更新记录值
	public String updateDeviceParam(final DeviceParamEntity deviceParamEntity){
		return new SQL(){
			   {
				UPDATE("device_parameter");
				if (deviceParamEntity.getParamName() != null) {
					SET("param_name = #{paramName}");
				}
				if (deviceParamEntity.getParamBaudrate() != null) {
					SET("param_baudrate = #{paramBaudrate}");
				}
				WHERE("param_id=#{paramId}");
		       }  
			}.toString();
	}

}
