package com.mh.eems.provider;

import java.text.MessageFormat;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.jdbc.SQL;

import com.mh.eems.entity.Excel2DeviceInstallEntity;
import com.mh.eems.entity.Excel2ExchangeDeviceEntity;
import com.mh.eems.entity.ExchangeDeviceEntity;

/**
 * @ClassName: ExchangeDeviceProvider
 * @Description:TODO(动态拼接SQL语句，查询更换表具资料)
 * @author: 铭汉科技—LJF
 * @date: 2019年11月18日 上午11:32:38
 */
public class ExchangeDeviceProvider {

    // 根据条件查询记录值
    public String queryByType(final ExchangeDeviceEntity exchangeDeviceEntity, Integer page, Integer limit) {
        StringBuffer sql = new StringBuffer("select id" +
                "      ,house_num" +
                "      ,house_address" +
                "      ,building_name" +
                "      ,device_num" +
                "      ,collection_num" +
                "      ,data_com" +
                "      ,last_value" +
                "      ,param_type" +
                "      ,new_device_num" +
                "      ,new_collection_num" +
                "      ,new_value" +
                "      ,convert(varchar(10),update_time,23) as update_time" +
                "      ,remark from exchange_devices where 1 = 1 ");
        if (page == null && limit == null) {
            if (exchangeDeviceEntity.getHouseNum() != null) {
                sql.append(" and house_num = #{exchangeDeviceEntity.houseNum}");
            }
        } else {
            if (exchangeDeviceEntity.getHouseNum() != null) {
                sql.append(" and house_num like concat('%',#{exchangeDeviceEntity.houseNum},'%')");
            }
        }
        if (exchangeDeviceEntity.getBuildingName() != null) {
            sql.append(" and building_name like concat('%',#{exchangeDeviceEntity.buildingName},'%')");
        }
        if (exchangeDeviceEntity.getParamType() != null) {
            sql.append(" and param_type like concat('%',#{exchangeDeviceEntity.paramType},'%')");
        }
        if (exchangeDeviceEntity.getDataCom() != null) {
            sql.append(" and data_com like concat('%',#{exchangeDeviceEntity.dataCom},'%')");
        }
        if (exchangeDeviceEntity.getUpdateTime() != null) {
            sql.append(" and convert(varchar(10),update_time,23) = #{exchangeDeviceEntity.deviceNum}");
        }
        if ((page != null) && (limit != null)) {
            sql.append(" order by id desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY ");
        }
        System.out.println(sql.toString());
        return sql.toString();
    }

    // 根据条件查询记录值
    public String queryCount(final ExchangeDeviceEntity exchangeDeviceEntity, Integer page, Integer limit) {
        StringBuffer sql = new StringBuffer("select count(*) from exchange_devices where 1 = 1 ");
        if (page == null && limit == null) {
            if (exchangeDeviceEntity.getHouseNum() != null) {
                sql.append(" and house_num = #{exchangeDeviceEntity.houseNum}");
            }
        } else {
            if (exchangeDeviceEntity.getHouseNum() != null) {
                sql.append(" and house_num like concat('%',#{exchangeDeviceEntity.houseNum},'%')");
            }
        }
        if (exchangeDeviceEntity.getBuildingName() != null) {
            sql.append(" and building_name like concat('%',#{exchangeDeviceEntity.buildingName},'%')");
        }
        if (exchangeDeviceEntity.getUpdateTime() != null) {
            sql.append(" and convert(varchar(10),update_time,23) = #{exchangeDeviceEntity.deviceNum}");
        }
        System.out.println(sql.toString());
        return sql.toString();
    }

    // 根据户号修改已添加的记录值
    public String updateDevice(final ExchangeDeviceEntity exchangeDeviceEntity) {
        String sqlString =
                new SQL() {
                    {
                        UPDATE("exchange_devices");
                        if (exchangeDeviceEntity.getHouseNum() != null) {
                            SET("house_num = #{houseNum}");
                        }
                        if (exchangeDeviceEntity.getHouseAddress() != null) {
                            SET("house_address = #{houseAddress}");
                        }
                        if (exchangeDeviceEntity.getBuildingName() != null) {
                            SET("building_name = #{buildingName}");
                        }
                        if (exchangeDeviceEntity.getDeviceNum() != null) {
                            SET("device_num = #{deviceNum}");
                        }
                        if (exchangeDeviceEntity.getCollectionNum() != null) {
                            SET("collection_num = #{collectionNum}");
                        }
                        if (exchangeDeviceEntity.getDataCom() != null) {
                            SET("data_com = #{dataCom}");
                        }
                        if (exchangeDeviceEntity.getLastValue() != null) {
                            SET("last_value = #{lastValue}");
                        }
                        if (exchangeDeviceEntity.getParamType() != null) {
                            SET("param_type = #{paramType}");
                        }
                        if (exchangeDeviceEntity.getNewDeviceNum() != null) {
                            SET("new_device_num = #{newDeviceNum}");
                        }
                        if (exchangeDeviceEntity.getNewCollectionNum() != null) {
                            SET("new_collection_num = #{newCollectionNum}");
                        }
                        if (exchangeDeviceEntity.getNewValue() != null) {
                            SET("new_value = #{newValue}");
                        }
                        if (exchangeDeviceEntity.getUpdateTime() != null) {
                            SET("update_time = #{updateTime}");
                        }
                        if (exchangeDeviceEntity.getRemark() != null) {
                            SET("remark = #{remark}");
                        }
                        if (exchangeDeviceEntity.getId() != null && exchangeDeviceEntity.getHouseNum() != null) {
                            WHERE("house_num=#{houseNum} and id = #{id}");
                        }
							WHERE("house_num=#{houseNum} ");
                    }
                }.toString();
        System.out.println(sqlString);
        return sqlString;
    }

    /* 批量插入 */
    @SuppressWarnings("unchecked")
    public String batchInsertDeviceByExcel(Map<?, ?> map) {

        List<Excel2ExchangeDeviceEntity> excel2ExchangeDeviceEntities = (List<Excel2ExchangeDeviceEntity>) map.get("list");
        StringBuilder sb = new StringBuilder();
        sb.append("insert into exchange_devices " +
                "(house_num,house_address,building_name,device_num,collection_num,data_com,last_value,param_type,"
                + "new_device_num,new_collection_num,new_value,update_time,remark) values ");
        MessageFormat mf = new MessageFormat(
                "(#'{'list[{0}].houseNum}, "
                        + "#'{'list[{0}].houseAddress}, "
                        + "#'{'list[{0}].buildingName}, "
                        + "#'{'list[{0}].deviceNum}, "
                        + "#'{'list[{0}].collectionNum}, "
                        + "#'{'list[{0}].dataCom}, "
                        + "#'{'list[{0}].lastValue}, "
                        + "#'{'list[{0}].paramType}, "
                        + "#'{'list[{0}].newDeviceNum}, "
                        + "#'{'list[{0}].newCollectionNum}, "
                        + "#'{'list[{0}].newValue}, "
                        + "#'{'list[{0}].updateTime}, "
                        + "#'{'list[{0}].remark})");

        for (int i = 0; i < excel2ExchangeDeviceEntities.size(); i++) {
            sb.append(mf.format(new Object[]{i}));
            if (i < excel2ExchangeDeviceEntities.size() - 1)
                sb.append(",");
        }
        System.out.println(sb.toString());
        return sb.toString();
    }

}
