package com.mh.eems.provider;

import com.mh.eems.entity.Excel2DeviceInstallEntity;
import org.apache.ibatis.jdbc.SQL;
import com.mh.eems.entity.GateWayManageEntity;
import com.mh.eems.entity.Excel2GatewayInstallEntity;
import java.text.MessageFormat;
import java.util.List;
import java.util.Map;

/**
 * 
 * @ClassName:  GatewayManageProvider   
 * @Description:TODO(动态添加网关参数管理SQL语句)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年7月31日 下午3:50:36   
 *
 */
public class GatewayManageProvider {
	/* 批量插入 */
	@SuppressWarnings("unchecked")
	public String batchInsertByExcel(Map<?, ?> map) {
		List<Excel2GatewayInstallEntity> Excel2GatewayInstallEntity = (List<Excel2GatewayInstallEntity>) map.get("list");
		StringBuilder sb = new StringBuilder();
		sb.append("insert into gateway_manage " +
				"(gateway_id," +
				"gateway_name," +
				"gateway_ip," +
				"gateway_address," +
				"data_com," +
				"collection_loop," +
				"create_date," +
				"internet_card,operator) values ");
		MessageFormat mf = new MessageFormat(
				"(#'{'list[{0}].gatewayId}, "
						+ "#'{'list[{0}].gatewayName}, "
						+ "#'{'list[{0}].gatewayIp}, "
						+ "#'{'list[{0}].gatewayAddress}, "
						+ "#'{'list[{0}].dateCom}, "
						+ "#'{'list[{0}].collectionLoop}, "
						+ "#'{'list[{0}].createDate}, "
						+ "#'{'list[{0}].internetCard}, "
						+ "#'{'list[{0}].operator})");
		for (int i = 0; i < Excel2GatewayInstallEntity.size(); i++) {
			sb.append(mf.format(new Object[] { i }));
			if (i < Excel2GatewayInstallEntity.size() - 1)
				sb.append(",");
		}
		return sb.toString();
	}
	
	// 按条件查询记录
	public String queryGatewayByOthers(final GateWayManageEntity gm, Integer page, Integer limit, String start, String end){
		StringBuffer sql = new StringBuffer("select * from gateway_manage where 1 = 1");
		if (gm.getGatewayId() != null) {
            sql.append(" and gateway_id = #{gm.gatewayId} ");
        } 
		if (gm.getGatewayName() != null && gm.getGatewayName() != "" ) {
            sql.append(" and gateway_name = #{gm.gatewayName} ");
        }
		if (gm.getStatus() != null) {
			sql.append(" and grade = #{gm.status}");
		}
		if (gm.getDataCom() != null && gm.getDataCom() != "") {
			sql.append(" and data_com = #{gm.dataCom}");
		}
		if (gm.getGatewayIp() != null && gm.getGatewayIp() != "") {
			sql.append(" and gateway_ip = #{gm.gatewayIp}");
		}
		if(gm.getInternetCard() !=null && gm.getInternetCard() !="") {
			sql.append(" and internet_card = #{gm.internetCard}");
		}
		if(gm.getOperator() != null) {
			sql.append(" and operator = #{gm.operator}");
		}
		if ((start != null&&start != "")&&(end != null && end != "")) {
			sql.append(" and convert(varchar(10),connect_date,23) >= #{start} and convert(varchar(10),connect_date,23) >= #{end}");
		}
		if ((page != null) && (limit != null)){
			sql.append(" order by id desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY ");
		}
		System.out.println(sql.toString());
        return sql.toString();
	}
	
	// 查询记录数
	public String queryGatewayCount(final GateWayManageEntity gm, Integer page, Integer limit, String start, String end) {
		StringBuffer sql = new StringBuffer("select top 1 count(*) from gateway_manage where 1 = 1");
		if (gm.getGatewayId() != null) {
            sql.append(" and gateway_id = #{gm.gatewayId} ");
        } 
		if (gm.getGatewayName() != null && gm.getGatewayName() != "" ) {
            sql.append(" and gateway_name = #{gm.gatewayName} ");
        }
		if (gm.getStatus() != null) {
			sql.append(" and grade = #{gm.status}");
		}
		if (gm.getDataCom() != null && gm.getDataCom() != "") {
			sql.append(" and data_com = #{gm.dataCom}");
		}
		if (gm.getGatewayIp() != null && gm.getGatewayIp() != "") {
			sql.append(" and gateway_ip = #{gm.gatewayIp}");
		}
		if ((start != null&&start != "")&&(end != null && end != "")) {
			sql.append(" and convert(varchar(10),connect_date,23) >= #{start} and convert(varchar(10),connect_date,23) >= #{end}");
		}
		System.out.println(sql.toString());
        return sql.toString();
	}
	
	// 查询是否有相同记录
	public String queryIsSame(final GateWayManageEntity gm) {
		StringBuffer sql = new StringBuffer("select top 1 * from gateway_manage where ");
		if (gm.getGatewayId() != null) {
            sql.append(" gateway_id = #{gm.gatewayId} ");
        } 
		if (gm.getDataCom() != null ) {
            sql.append(" and data_com = #{gm.dataCom} ");
        }
		System.out.println(sql.toString());
        return sql.toString();
	}
	
	// 修改网关设备信息内容
	public String updateGateway(final GateWayManageEntity gm) {
		return new SQL() {
			{
				UPDATE("gateway_manage");
				if (gm.getGatewayName() != null) {
					SET("gateway_name = #{gm.gatewayName}");
				}
				if (gm.getGatewayIp() != null) {
					SET("gateway_ip = #{gm.gatewayIp}");
				}
				if (gm.getGatewayAddress() != null) {
					SET("gateway_address = #{gm.gatewayAddress}");
				}
				if (gm.getDataCom() != null) {
					SET("data_com = #{gm.dataCom}");
				}
				if (gm.getLoop() != null) {
					SET("collection_loop = #{gm.loop}");
				}
				if(gm.getInternetCard() != null) {
					SET("internet_card =#{gm.internetCard}");
				}
				if(gm.getOperator() != null) {
					SET("operator =#{gm.operator}");
				}
				WHERE("gateway_id=#{gm.gatewayId}");
			}
		}.toString();
	}

}
