package com.mh.eems.provider;

import java.text.MessageFormat;
import java.util.List;
import java.util.Map;

import com.mh.eems.util.DateUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.ibatis.jdbc.SQL;

import com.mh.eems.entity.DeviceData;
import com.mh.eems.entity.DeviceInstallEntity;
import com.mh.eems.entity.UserEntity;

/**
 * @ClassName: UserProvider
 * @Description:TODO(用户动态拼接SQL语句)
 * @author: 铭汉科技—LJF
 * @date: 2019年8月1日 下午6:20:37
 */
public class UserProvider {

    // 更新数据
    public String updateUser(final UserEntity userEntity) {

        String sqlStr = new SQL() {
            {
                UPDATE("user_manage");
                if (userEntity.getHouseAddress() != null) {
                    SET("house_address = #{userEntity.houseAddress}");
                }
                if (userEntity.getDeviceNum() != null) {
                    SET("device_num = #{userEntity.deviceNum}");
                }
                if (userEntity.getCollectionNum() != null) {
                    SET("collection_num = #{userEntity.collectionNum}");
                }
                if (userEntity.getRemark() != null) {
                    SET("remark = #{userEntity.remark}");
                }
                if (userEntity.getParentId() != null) {
                    SET("parent_id = #{userEntity.parentId}");
                }
                SET("update_time = getdate()");
                if (userEntity.getParentId() != null && userEntity.getHouseNum() != null) {
                    WHERE("id=#{userEntity.id} and house_num = #{userEntity.houseNum}");
                }else{
                    WHERE("house_num = #{userEntity.houseNum}");
                }
            }
        }.toString();
        System.out.println(sqlStr);
        return sqlStr;

    }

    // 通过条件查询基表信息
    public String queryUsersByOthered(final UserEntity user, Integer page, Integer limit) {
        StringBuffer sql = new StringBuffer("select *,#{user.nodeName} as node_name from user_manage where 1 = 1 ");
        if (user.getParentId() != null) {
            sql.append(" and parent_id = #{user.parentId} ");
        }
        if ((page == null) && (limit == null)) {
            if (user.getHouseNum() != null && user.getHouseNum() != "") {
                sql.append(" and house_num  = #{user.houseNum} ");
            }
        } else {
            if (user.getHouseNum() != null && user.getHouseNum() != "") {
                sql.append(" and house_num like concat('%',#{user.houseNum},'%')");
            }
        }
        if (user.getDeviceNum() != null && user.getDeviceNum() != "") {
            sql.append(" and device_num like concat('%',#{user.deviceNum},'%')");
        }
        if (user.getCollectionNum() != null && user.getCollectionNum() != "") {
            sql.append(" and collection_num like concat('%',#{user.collectionNum},'%')");
        }
        if ((page != null) && (limit != null)) {
            sql.append(" order by id desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY ");
        }
        System.out.println(sql.toString());
        return sql.toString();
    }

    // 查询记录数
    public String queryCountByOther(final UserEntity user, Integer page, Integer limit) {
        StringBuffer sql = new StringBuffer("select top 1 count(*) from user_manage where 1 = 1 and node_type = 99 ");
        if (user.getParentId() != null) {
            sql.append(" and parent_id = #{user.parentId} ");
        }
        if (user.getHouseNum() != null && user.getHouseNum() != "") {
            sql.append(" and house_num like concat('%',#{user.houseNum},'%')");
        }
        if (user.getDeviceNum() != null && user.getDeviceNum() != "") {
            sql.append(" and device_num like concat('%',#{user.deviceNum},'%')");
        }
        if (user.getCollectionNum() != null && user.getCollectionNum() != "") {
            sql.append(" and collection_num like concat('%',#{user.collectionNum},'%')");
        }
        System.out.println(sql.toString());
        return sql.toString();
    }

    /* 批量插入 */
    @SuppressWarnings("unchecked")
    public String batchInsertByExcel(Map<?, ?> map) {

        List<UserEntity> userEntities = (List<UserEntity>) map.get("list");
        StringBuilder sb = new StringBuilder();
        sb.append("insert into user_manage(house_num,node_type,house_address,device_num,collection_num,remark,parent_id,update_time) values ");
        MessageFormat mf = new MessageFormat(
                "(#'{'list[{0}].houseNum}, "
                        + "99, "
                        + "#'{'list[{0}].houseAddress}, "
                        + "#'{'list[{0}].deviceNum}, "
                        + "#'{'list[{0}].collectionNum}, "
                        + "#'{'list[{0}].remark}, "
                        + "(select id from user_manage where house_num = #'{'list[{0}].nodeName}), "
                        + "getdate())");

        for (int i = 0; i < userEntities.size(); i++) {
            sb.append(mf.format(new Object[]{i}));
            if (i < userEntities.size() - 1)
                sb.append(",");
        }
        return sb.toString();
    }

//	/* 批量删除 */
//	public String batchDelete(Map<?, ?> map) {
//		List<UserEntity> deviceDatas = (List<UserEntity>) map.get("list");
//		StringBuilder sb = new StringBuilder();
//		sb.append("DELETE FROM student WHERE id IN (");
//		for (int i = 0; i < deviceDatas.size(); i++) {
//			sb.append("'").append(deviceDatas.get(i).getDeviceID()).append("'");
//			if (i < deviceDatas.size() - 1)
//				sb.append(",");
//		}
//		sb.append(")");
//		return sb.toString();
//	}

//		List<UserEntity> deviceDatas = (List<UserEntity>) map.get("list");
//		StringBuilder sb = new StringBuilder();
//		sb.append("DELETE FROM student WHERE id IN (");
//		for (int i = 0; i < deviceDatas.size(); i++) {
//			sb.append("'").append(deviceDatas.get(i).getDeviceID()).append("'");
//			if (i < deviceDatas.size() - 1)
//				sb.append(",");
//		}
//		sb.append(")");
//		return sb.toString();
//	}

}