package com.mh.eems.provider;

import java.util.Map;

/**
 * 时间用量分析
 */
public class UserProvider2 {
    // 通过条件查询基表信息
    public String queryUsersByOtheredMap(Map<String, Object> map) {
        StringBuffer sql = new StringBuffer("");
        int timeLen = (int) map.get("timeLen");
        String level = map.get("level").toString();
        String time = (String) map.get("time");
        String nodeName = (String) map.get("nodeName");
        String page = map.get("page").toString();
        String limit = map.get("limit").toString();

        if (timeLen == 0 || timeLen == 11) {
            sql = sqlYear(level, time, nodeName, limit);   //根据年
            //  System.out.println(sql.toString());
        }
        if (timeLen == 17) {
            sql = sqlMonth(level, time, nodeName, limit, page);   //根据月
            //    System.out.println(sql.toString());
        }
        if (timeLen == 23) {
            sql = sqlDay(level, time, nodeName, limit, page);  //根据日
            // System.out.println(sql.toString());
        }
        System.out.println(sql.toString());
        return sql.toString();
    }

    /**
     * 按年查询
     *
     * @param level
     * @param time
     * @param nodeName
     * @param limit
     * @return
     */
    public StringBuffer sqlYear(String level, String time, String nodeName, String limit) {
        int intstart = Integer.parseInt(time.substring(0, 4));
        int intend = Integer.parseInt(time.substring(7, 11));
        int yaerCount = intend - intstart;
        StringBuffer sql = new StringBuffer("");
        if (level.equals("1") || level == null || level.equals("0")) {
            /**
             * 查询整个狮山总量
             */
            sql.append(" SELECT ROW_NUMBER() over(order by a.cur_date) id ,(SELECT house_num FROM user_manage WHERE house_num = '" +
                    nodeName +
                    "') 'name',a.cur_date 'time',SUM( a.calc_flow ) 'totalUsed' FROM ( SELECT * FROM wt_building_year");
            for (int i = 0; i <= yaerCount; i++) {
                sql.append(" UNION SELECT * FROM wt_building_year" + (intstart + i));
            }
            sql.append(") AS a WHERE a.areas_name IN (SELECT house_num FROM user_manage WHERE parent_id in ((SELECT id  FROM user_manage WHERE parent_id = (SELECT id FROM user_manage WHERE house_num = '" +
                    nodeName +
                    "')))) and a.cur_date BETWEEN '" + intstart + "' AND '" + intend + "' GROUP BY a.cur_date ORDER BY a.cur_date");
            //  System.out.println(sql.toString());
        }
        if (level.equals("2") && level != null) {
            /**
             * 查询节点为2的区域用量
             */
            sql.append("SELECT ROW_NUMBER() over(order by a.cur_date) id,( SELECT house_num FROM user_manage WHERE house_num ='"
                    + nodeName + "') 'name',CONVERT(varchar(12) ,a.cur_date, 110 ) 'time',SUM(a.calc_flow)'totalUsed' FROM (SELECT * FROM wt_building_year ");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_year" + (intstart + i));
            }
            sql.append(" ) AS a  WHERE a.areas_name IN ( ( SELECT house_num FROM user_manage WHERE parent_id = (SELECT id FROM user_manage WHERE house_num = '" +
                    nodeName + "' ) ) ) and  a.cur_date BETWEEN '" + intstart + "' AND '" + (intend + 1) + "' GROUP  BY a.cur_date ORDER BY a.cur_date");
            //  System.out.println(sql.toString());
        }
        if (level.equals("3") && level != null) {
            /**
             * 查询节点为3的区域用量
             */
            sql.append("SELECT ROW_NUMBER() over(order by a.cur_date) id,(SELECT house_num FROM user_manage WHERE house_num = '" +
                    nodeName + "') 'name',CONVERT(varchar(12) ,a.cur_date, 110 ) 'time',SUM(a.calc_flow)'totalUsed' FROM (SELECT * FROM wt_building_year");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_year" + (intstart + i));
            }
            sql.append(") AS a WHERE a.building_name IN ((SELECT house_num FROM user_manage WHERE parent_id = (SELECT id FROM user_manage WHERE house_num = '" +
                    nodeName + "'))) and a.cur_date BETWEEN '" + intstart + "' AND '" + (intend + 1) + "' GROUP BY a.cur_date ORDER BY a.cur_date");
            //  System.out.println(sql.toString());
        }
        if (level.equals("4") && level != null) {
            /**
             * 查询节点为4的区域用量
             */
            sql.append("SELECT ROW_NUMBER() over(order by a.cur_date) id,a.building_name 'name' ,CONVERT(varchar(12) ,a.cur_date, 110 ) 'time',a.calc_flow 'totalUsed' FROM (SELECT * FROM wt_building_month");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_year" + (intstart + i));

            }
            sql.append(") AS a  WHERE a.building_name ='" + nodeName + "' and a.cur_date BETWEEN '" + intstart + "' AND '" + (intend + 1) + "' ORDER BY a.cur_date");
            //
        }
        System.out.println(sql.toString());
        return sql;
    }

    /**
     * 按月查询
     *
     * @param level
     * @param time
     * @param nodeName
     * @param limit
     * @return
     */
    public StringBuffer sqlMonth(String level, String time, String nodeName, String limit, String page) {
        int intstart = Integer.parseInt(time.substring(0, 4));
        int intend = Integer.parseInt(time.substring(10, 14));
        String start = time.substring(0, 7);
        String end = time.substring(10, 17);
        int yaerCount = intend - intstart;
        StringBuffer sql = new StringBuffer();
        sql.append("SELECT * FROM (");
        if (level.equals("1") && level != null) {
            /**
             * 根据节点3查询
             */
            sql.append("SELECT ROW_NUMBER() over(ORDER BY a.cur_date) id,CONVERT (VARCHAR(12),a.cur_date,110) 'time',(SELECT house_num FROM user_manage WHERE house_num = '"
                    + nodeName + "') 'name',SUM ( a.calc_flow ) 'totalUsed' FROM (SELECT * FROM wt_building_month");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_month" + (intstart + i));
            }
            sql.append(") AS a  WHERE a.areas_name IN (SELECT house_num FROM user_manage WHERE parent_id IN ((SELECT id FROM user_manage WHERE parent_id = ( SELECT id FROM user_manage WHERE house_num = '" +
                    nodeName +
                    "')))) AND a.cur_date  BETWEEN '" + start + "' AND '" + end + "' GROUP BY a.cur_date ");
        }
        if (level.equals("2") && level != null) {
            /**
             * 根据节点3查询
             */
            sql.append("SELECT ROW_NUMBER() over (ORDER BY a.cur_date) id,CONVERT (VARCHAR ( 12 ),a.cur_date, 110 ) 'time',( SELECT house_num FROM user_manage WHERE house_num = '"
                    + nodeName + "' ) 'name' ,SUM (a.calc_flow)'totalUsed' FROM ( SELECT * FROM wt_building_month");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_month" + (intstart + i));
            }

            sql.append(") AS a  WHERE a.areas_name IN ( ( SELECT house_num FROM user_manage WHERE parent_id=(SELECT id FROM user_manage WHERE house_num = '" +
                    nodeName + "'))) AND  a.cur_date  BETWEEN '" + start + "' AND '" + end + "' GROUP BY a.cur_date  ");
        }
        if (level.equals("3") && level != null) {
            /**
             * 根据节点3查询
             */
            sql.append("SELECT ROW_NUMBER() over (ORDER BY a.cur_date) id,CONVERT(VARCHAR(12),a.cur_date, 110)'time',( SELECT house_num FROM user_manage WHERE house_num = '"
                    + nodeName + "')'name' ,SUM ( a.calc_flow )'totalUsed' FROM (SELECT * FROM wt_building_month");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_month" + (intstart + i));
            }
            sql.append(") AS a  WHERE a.areas_name ='" + nodeName + "' AND a.cur_date BETWEEN '" + start + "' AND '" + end + "' GROUP BY a.cur_date ");
        }
        if (level.equals("4") && level != null) {
//            /**
//             * 根据节点4查询
//             */
//            sql.append("SELECT ROW_NUMBER() over (ORDER BY a.cur_date)id, CONVERT(VARCHAR(12),a.cur_date,110) 'time',a.building_name 'name' ,a.calc_flow 'totalUsed' FROM ( SELECT * FROM wt_building_month ");
//            for (int i = 0; i <= yaerCount; i++) {
//
//                sql.append(" UNION SELECT * FROM wt_building_month" + (intstart + i));
//            }
//
//            sql.append(") AS a  WHERE a.building_name ='"+nodeName +"' AND a.cur_date BETWEEN '" +start +"' AND '" +end +"' ORDER BY a.cur_date");
            sql.append(getLevel(nodeName, "month", yaerCount, intstart, start, end));
        }
        if (page.equals("0")) {
            sql.append(") AS temp");
        } else {
            sql.append(") AS temp  WHERE id BETWEEN (" + page + "-1) * " + limit + " + 1 AND " + page + " * 10");
        }
        // System.out.println(sql.toString());
        return sql;
    }

    /**
     * 按日查询
     *
     * @param level
     * @param time
     * @param nodeName
     * @param limit
     * @return
     */
    public StringBuffer sqlDay(String level, String time, String nodeName, String limit, String page) {
        int intstart = Integer.parseInt(time.substring(0, 4) + time.substring(5, 7));
        int intend = Integer.parseInt(time.substring(13, 17) + time.substring(18, 20));
        String start = time.substring(0, 11);
        String end = time.substring(13, 23);
        int yaerCount = intend - intstart;
        StringBuffer sql = new StringBuffer();
        sql.append("SELECT * FROM (");
        if (level.equals("1") && level != null) {
            /**
             * 根据节点1查询
             */
            sql.append("SELECT ROW_NUMBER () over (ORDER BY a.cur_date) id,CONVERT(VARCHAR(10),a.cur_date,120)'time',(SELECT house_num FROM user_manage WHERE house_num ='"
                    + nodeName + "')'name',SUM (a.calc_flow)'totalUsed' FROM (SELECT * FROM wt_building_day");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_day" + (intstart + i));
            }

            sql.append(") AS a  WHERE a.areas_name IN (SELECT house_num FROM user_manage WHERE parent_id IN ( ( SELECT id FROM user_manage WHERE parent_id = (SELECT id FROM user_manage WHERE house_num ='" +
                    nodeName + "')))) AND  a.cur_date BETWEEN '" + start + "' AND '" + end + "' GROUP BY a.cur_date");
        }
        if (level.equals("2") && level != null) {
            /**
             * 根据节点2查询
             */
            sql.append("SELECT ROW_NUMBER() over(ORDER BY a.cur_date)id,CONVERT(VARCHAR(10),a.cur_date,120)'time',(SELECT house_num FROM user_manage WHERE house_num ='"
                    + nodeName + "' ) 'name' ,SUM (a.calc_flow)'totalUsed' FROM(SELECT * FROM wt_building_day");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_day" + (intstart + i));
            }

            sql.append(") AS a  WHERE a.areas_name IN ( ( SELECT house_num FROM user_manage WHERE parent_id=(SELECT id FROM user_manage WHERE house_num = '"
                    + nodeName + "' ) ) ) AND  a.cur_date  BETWEEN '" + start + "' AND '" + end + "' GROUP BY a.cur_date ");
        }
        if (level.equals("3") && level != null) {
            /**
             * 根据节点3查询
             */
            sql.append("SELECT ROW_NUMBER() over(ORDER BY a.cur_date)id,CONVERT(VARCHAR(10),a.cur_date,120)'time',(SELECT house_num FROM user_manage WHERE house_num = '" + nodeName + "')'name' , " +
                    " SUM(a.calc_flow)'totalUsed' FROM (SELECT * FROM wt_building_day");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_day" + (intstart + i));
            }

            sql.append(") AS a  WHERE a.areas_name ='" + nodeName + "' AND a.cur_date BETWEEN '" + start + "' AND '" + end + "' GROUP BY a.cur_date");
        }
        if (level.equals("4") && level != null) {
            /**
             * 根据节点4查询
             */
            sql.append("SELECT ROW_NUMBER()over(ORDER BY a.cur_date)id,CONVERT(VARCHAR(10),a.cur_date,120)'time',a.building_name'name' ,a.calc_flow'totalUsed' FROM (SELECT * FROM wt_building_day");
            for (int i = 0; i <= yaerCount; i++) {

                sql.append(" UNION SELECT * FROM wt_building_day" + (intstart + i));
            }

            sql.append(") AS a  WHERE a.building_name = '" + nodeName + "' AND a.cur_date BETWEEN '" + start + "' AND '" + end + "'");
        }
        if (page.equals("0")) {
            sql.append(") AS temp");
        } else {
            sql.append(") AS temp  WHERE id BETWEEN (" + page + "-1) * " + limit + " + 1 AND " + page + " * 10");
        }

        //   System.out.println(sql.toString());
        return sql;
    }

    /**
     * 封装根据节点组成sql
     *
     * @param nodeName
     * @param table
     * @param count
     * @param intStart
     * @param start
     * @param end
     * @return
     */
    public StringBuffer getLevel(String nodeName, String table, int count, int intStart, String start, String end) {
        StringBuffer sql = new StringBuffer();

        sql.append("SELECT ROW_NUMBER()over(ORDER BY a.cur_date)id,CONVERT(VARCHAR(10),a.cur_date,120)'time',a.building_name'name' ,a.calc_flow'totalUsed' FROM (SELECT * FROM wt_building_" + table);
        for (int i = 0; i <= count; i++) {

            sql.append(" UNION SELECT * FROM wt_building_" + table + (intStart + i));
        }

        sql.append(") AS a  WHERE a.building_name = '" + nodeName + "' AND a.cur_date BETWEEN '" + start + "' AND '" + end + "'");
        return sql;
    }

    public StringBuffer queryUserUsageAnalysisByOtheredMap(Map<String, Object> map) {
        boolean  flag =true;
        StringBuffer sql = new StringBuffer("select a.now_value, a.id,a.house_num,convert(varchar(10),a.flow_time,120)'flow_time',a.total_value,a.last_value'month_Value',a.flow,a.last_flow,a.day_flow,a.last_day_flow,a.year_flow,a.last_year_flow,a.day_zero,a.month_zero,a.exception_count,a.abnorma_count FROM user_flow a " );
        if (map.get("areaName") != null&&!map.get("areaName").equals("")) {
            sql.append("left join device_install b on a.house_num = b.house_num where 1=1 and b.building_name =#{areaName}");
            flag=false;
        }
        if (map.get("houseNum") != null&&!map.get("houseNum").equals("")) {
            if(flag){
                sql.append(" where a.house_num = #{houseNum}");
            }else {
                sql.append(" and a.house_num = #{houseNum}");
            }

        }

        sql.append(" order by id desc offset (#{page} - 1) * #{limit} rows FETCH NEXT #{limit} ROWS ONLY ");
        System.out.println(sql);
        return sql;
    }
}
