package com.mh.eems.service;

import java.util.List;

import com.mh.eems.dto.RoleAndPermissionDto;
import com.mh.eems.entity.PermissionEntity;
import com.mh.eems.entity.RoleEntity;

/**
 * 
 * @ClassName:  RoleService   
 * @Description:TODO(角色服务类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年7月24日 上午11:15:17   
 *
 */
public interface RoleService {
	
	// 查询全部角色
	List<RoleEntity> queryAllRoles(int page,int limit);
	
	// 通过roleId查询权限
	List<RoleAndPermissionDto> queryRoleAndPermission(Long id);
	
	//根据roleName查询是否有值
	RoleEntity queryRoleByRoleName(RoleEntity roleEntity);
	
	// 查询记录数
	int queryRoleCount();
	
	// 插入数据
	int insertRole(RoleEntity roleEntity);
	
	// 往role和permission的中间表插入全部的权限
	int insertRoleAndPermisson();
	
	// 往role和user的中间表插入全部的权限
	int InsertRoleAndUser();
	
	// 删除数据
	int deleteRoleById(Object roleId);
	
	// 删除对应的角色权限表
	int deleteRolePermissionById(Object roleId);
	
	// 通过ID更新sys_role值
	int updateRoleById(RoleEntity roleEntity);
	
	// 更新sys_role_permission
	int updateRolePermission(List<PermissionEntity> pList);

	List<RoleEntity> queryAllRoles1();
	
}
