package com.mh.eems.service;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.mh.eems.entity.Excel2UserEntity;
import com.mh.eems.entity.UserEntity;
import com.mh.eems.entity.UserTreeEntity;

/**
 * 
 * @ClassName:  UserService   
 * @Description:TODO(用户资料管理接口)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月1日 下午3:12:13   
 *
 */
public interface UserService {
	
	// 通过excel批量导入数据库
	int batchInsert(List<Object> excel2UserEntities);
	
	// 用户树形
	List<UserTreeEntity> queryUserTree();
	
	// 添加树形节点
	int insertUserTree(UserTreeEntity userTreeEntity);

	// 更新树形结构节点
	int updateUserTree(UserTreeEntity userTreeEntity);
	
	// 删除树形结构节点
	int deleteUserTree(int id);
	
	// 查询树节点对应的值
	List<UserEntity> queryUsers(UserTreeEntity userTreeEntity,Integer page,Integer limit);
	
	// 根据ID查询树节点对应的值
	List<UserEntity> queryUserById(String title,int id);
	
	// 查询记录总数
	int queryUsersCount(UserEntity userEntity, Integer page, Integer limit);
	
	// 根据ID删除数据
	int deleteUser(int id);
	
	// 添加用户信息
	String insertUser(UserEntity userEntity);
	
	// 更新用户信息
	int updateUser(UserEntity userEntity);
	
	// 根据条件查询内容
	List<UserEntity> queryUserByOthers(UserEntity userEntity, Integer page, Integer limit);

}
