/**
* <p>Title: DeviceInstallServiceImpl.java</p>  
* <p>Description: </p>  
* <p>Copyright: Copyright (c) 2017</p>  
* <p>Company: xiaoer</p>  
* @author LJF
* @date 2019年8月6日  
* @version 1.0  
*/  
package com.mh.eems.service.impl;

import java.sql.SQLException;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.mh.eems.entity.DeviceInstallEntity;
import com.mh.eems.entity.UserEntity;
import com.mh.eems.mapper.DeviceInstallMapper;
import com.mh.eems.service.DeviceInstallService;
import com.mh.eems.util.SysLogUtil;

/**  
* <p>Title: DeviceInstallServiceImpl</p>  
* <p>Description: 基表安装信息实现类</p>  
* @author LJF
* @date 2019年8月6日  
*/

@Primary
@Service

public class DeviceInstallServiceImpl implements DeviceInstallService {

	@Autowired
	private DeviceInstallMapper deviceInstallMapper;
	
	@Override
//    @Cacheable("DeviceInstallEntity")
	public List<DeviceInstallEntity> queryDevices(int page, int limit) {
		// TODO Auto-generated method stub
		return deviceInstallMapper.queryDevices(page, limit);
	}

	@Override
	public String insertInstall(DeviceInstallEntity dInstallEntity) throws SQLException {
		// TODO Auto-generated method stub
		String result = null;
		int is_exists = deviceInstallMapper.queryDevicesIsSame(dInstallEntity);
		try {
			if (is_exists != 0) {
				result = "户号重复或者其他错误，请重新添加";
			} else {
				int a = deviceInstallMapper.insertInstall(dInstallEntity);
				if (a != 0) {
					// 插入日志
					try {
						SysLogUtil sysLogsUtil = new SysLogUtil();
						sysLogsUtil.logSave("基表管理", 
								"添加基表信息："+dInstallEntity.toString(),
								"添加");
					} catch (Throwable e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					result = "success";
				}
			}
		} catch (Exception e) {
			// TODO: handle exception
			result = "户号重复或者其他错误，请重新添加";
		}
		
		return result;
	}

	@Override
	public int updateInstalls(DeviceInstallEntity dInstallEntity) {
		// TODO Auto-generated method stub
		// 插入日志
		try {
			SysLogUtil sysLogsUtil = new SysLogUtil();
			sysLogsUtil.logSave("基表管理", 
					"更新基表信息："+dInstallEntity.toString(),
					"更新");
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return deviceInstallMapper.updateInstalls(dInstallEntity);
	}

	@Override
	public int deleteInstall(String houseNum) {
		// TODO Auto-generated method stub
		// 插入日志
		try {
			SysLogUtil sysLogsUtil = new SysLogUtil();
			sysLogsUtil.logSave("基表管理", 
					"根据户号删除基表信息："+houseNum,
					"删除");
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return deviceInstallMapper.deleteInstall(houseNum);
	}

	@Override
	public int queryCount(DeviceInstallEntity dInstallEntity, String startTime, String endTime) {
		// TODO Auto-generated method stub
		return deviceInstallMapper.queryCount(dInstallEntity, startTime, endTime);
	}

	@Override
//    @Cacheable("DeviceInstallEntity")
	public List<DeviceInstallEntity> queryType(DeviceInstallEntity dInstallEntity, Integer page, Integer limit,
			String startTime, String endTime) {
		// TODO Auto-generated method stub
		return deviceInstallMapper.queryType(dInstallEntity, page, limit, startTime, endTime);
	}

	@Override
	public List<UserEntity> queryDeviceByHouseNum(String houseNum) {
		// TODO Auto-generated method stub
		return deviceInstallMapper.queryDeviceByHouseNum(houseNum);
	}

	@Override
	public void updateDeviceGateway() {
		// TODO Auto-generated method stub
		deviceInstallMapper.updateDeviceGateway();
	}

	@Override
	public int deviceBatchInsert(List<Object> excel2DeviceInstallEntities) {
		// TODO Auto-generated method stub
		return deviceInstallMapper.deviceBatchInsert(excel2DeviceInstallEntities);
	}

}
