package com.mh.eems.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.mh.eems.entity.ExchangeDeviceEntity;
import com.mh.eems.mapper.ExchangeDeviceMapper;
import com.mh.eems.service.ExchangeDeviceService;

@Primary
@Service
public class ExchangeDeviceServiceImpl implements ExchangeDeviceService {

	@Autowired
	private ExchangeDeviceMapper exchangeDeviceMapper;
	
	@Override
	public List<ExchangeDeviceEntity> queryType(ExchangeDeviceEntity exchangeDeviceEntity, Integer page,
			Integer limit) {
		// TODO Auto-generated method stub
		return exchangeDeviceMapper.queryType(exchangeDeviceEntity, page, limit);
	}

	@Override
	public int queryCount(ExchangeDeviceEntity exchangeDeviceEntity, Integer page, Integer limit) {
		// TODO Auto-generated method stub
		return exchangeDeviceMapper.queryCount(exchangeDeviceEntity, page, limit);
	}

	@Override
	public void insertExchangeDevice(ExchangeDeviceEntity exchangeDeviceEntity) {
		// TODO Auto-generated method stub
		exchangeDeviceMapper.insertExchangeDevice(exchangeDeviceEntity);
	}

	@Override
	public void updateExchangeDevice(ExchangeDeviceEntity exchangeDeviceEntity) {
		exchangeDeviceMapper.updateExchangeDevice(exchangeDeviceEntity);
		//删除在wt_now里的关联数据
		exchangeDeviceMapper.deleteWtNow(exchangeDeviceEntity.getHouseNum());
		
		//查询历史表是否需要更新
		int counts=exchangeDeviceMapper.findHouseNoCount(exchangeDeviceEntity.getNewDeviceNum());
		if(counts>0) {
			exchangeDeviceMapper.updateHouseNo(exchangeDeviceEntity.getHouseNum(), exchangeDeviceEntity.getNewDeviceNum());
		}
	}

	@Override
	public void deleteExchangeDevice(Long id) {
		// TODO Auto-generated method stub
		exchangeDeviceMapper.deleteExchangeDevice(id);
	}

	@Override
	public int batchInsertDevice(List<Object> excel2ExchangeDeviceEntities) {
		// TODO Auto-generated method stub
		return exchangeDeviceMapper.batchInsertDevice(excel2ExchangeDeviceEntities);
	}
	
	

}
