package com.mh.eems.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.mh.eems.annotation.LogAnnotation;
import com.mh.eems.dto.GatewayStatusDto;
import com.mh.eems.entity.GateWayManageEntity;
import com.mh.eems.mapper.GatewayManageMapper;
import com.mh.eems.service.GatewayService;
import com.mh.eems.util.SysLogUtil;

/**
 * 
 * @ClassName:  GatewayServiceImpl   
 * @Description:TODO(网关接口实现类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年7月31日 下午5:01:12   
 *
 */
@Primary
@Service
public class GatewayServiceImpl implements GatewayService {

	@Autowired
	private GatewayManageMapper gatewayManageMapper;
	
	@LogAnnotation(module = "网关管理", logs = "通过条件查询网关信息", type = "查询")
	@Override
	public List<GateWayManageEntity> queryGatewayByOther(GateWayManageEntity gm, Integer page, Integer limit, String start, String end) {
		// TODO Auto-generated method stub
		return gatewayManageMapper.queryGatewayByOther(gm, page, limit, start, end);
	}

	@Override
	public int queryGatewayCount(GateWayManageEntity gm, Integer page, Integer limit, String start, String end) {
		// TODO Auto-generated method stub
		return gatewayManageMapper.queryGatewayCount(gm, page, limit, start, end);
	}

	@Override
	public String addGateway(GateWayManageEntity gateWayManageEntity) {
		// TODO Auto-generated method stub
		// 查询是否有重复值
		GateWayManageEntity gateWayManageEntity2 = gatewayManageMapper.queryIsSame(gateWayManageEntity);
		if (gateWayManageEntity2 != null) {
			return "网关ID或者网关COM口重复,请重新编辑";
		} else {
			// 插入日志
			try {
				SysLogUtil sysLogsUtil = new SysLogUtil();
				sysLogsUtil.logSave("网关管理", 
						"插入网关信息："+gateWayManageEntity.toString(),
						"添加");
			} catch (Throwable e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			//2019-12-20 增加字段插入
			gatewayManageMapper.addGateway(gateWayManageEntity);
			return "success";
		}
	}

	@Override
	public String updateGateway(GateWayManageEntity gateWayManageEntity) {
		// TODO Auto-generated method stub
		// 查询是否有重复值
//		GateWayManageEntity gateWayManageEntity2 = gatewayManageMapper.queryIsSame(gateWayManageEntity);
//		if (gateWayManageEntity2 != null) {
//			return "网关ID或者网关COM口重复,请重新编辑";
//		} else {
			// 插入日志
			try {
				SysLogUtil sysLogsUtil = new SysLogUtil();
				sysLogsUtil.logSave("网关管理", 
						"更新网关信息："+gateWayManageEntity.toString(),
						"更新");
			} catch (Throwable e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return "网关ID或者网关COM口重复,请重新编辑";
			}
			//2019-12-20 增加更新的字段
			gatewayManageMapper.updateGateway(gateWayManageEntity);
			return "success";
//		}
	}

	@Override
	public int deleteGaway(long gatewayId) {
		// TODO Auto-generated method stub
		// 插入日志
		try {
			SysLogUtil sysLogsUtil = new SysLogUtil();
			sysLogsUtil.logSave("网关管理", 
					"通过ID "+gatewayId+" 删除网关信息",
					"删除");
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return gatewayManageMapper.deleteGaway(gatewayId);
	}

	@Override
	public List<GatewayStatusDto> queryStatusForGateway() {
		// TODO Auto-generated method stub
		return gatewayManageMapper.queryStatusForGateway();
	}

	@Override
	public int GatewayBatchInsert(List<Object> excel2GatewayInstallEntities) {
		return gatewayManageMapper.gatewayBatchInsert(excel2GatewayInstallEntities);
	}

}
