package com.mh.eems.service.impl;

import java.util.List;

import org.apache.ibatis.annotations.Param;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.mh.eems.dto.UserAndRoleDto;
import com.mh.eems.entity.PermissionEntity;
import com.mh.eems.mapper.PermissionMapper;
import com.mh.eems.mapper.SysUserMapper;
import com.mh.eems.service.PermissionService;

@Primary
@Service
public class PermissionServiceImpl implements PermissionService {

	private static final Logger log = LoggerFactory.getLogger("adminLogger");

	@Autowired
	private PermissionMapper permissionMapper;
	
	@Autowired
	private SysUserMapper userMapper;

	@Override
	public void save(PermissionEntity permission) {
		permissionMapper.save(permission);

		log.debug("新增菜单{}", permission.getName());
	}

	@Override
	public void update(PermissionEntity permission) {
		permissionMapper.update(permission);
	}

	@Override
	@Transactional
	public void delete(Long id) {
		permissionMapper.deleteRolePermission(id);
		permissionMapper.delete(id);
		permissionMapper.deleteByParentId(id);

		log.debug("删除菜单id:{}", id);
	}

	@Override
	public List<PermissionEntity> listByUserId(Long userId) {
		// TODO Auto-generated method stub
		// 查询对应的role_id
			int roleId = userMapper.querySysUserAndRoleByUserId1(userId);
		return permissionMapper.listByUserId(userId,roleId);
	}

	@Override
	public List<PermissionEntity> listByRoleId(Long roleId) {
		// TODO Auto-generated method stub
		return permissionMapper.listByRoleId(roleId);
	}

}
