package com.mh.eems.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.mh.eems.dto.RoleAndPermissionDto;
import com.mh.eems.entity.PermissionEntity;
import com.mh.eems.entity.RoleEntity;
import com.mh.eems.mapper.RoleMapper;
import com.mh.eems.service.RoleService;
import com.mh.eems.util.SysLogUtil;

@Primary
@Service
public class RoleServiceImpl implements RoleService {

	@Autowired
	private RoleMapper roleMapper;
	/**
	 * 查询全部的角色
	 */
	@Override
	public List<RoleEntity> queryAllRoles(int page,int limit) {
		// TODO Auto-generated method stub
		return roleMapper.queryAllRoles(page,limit);
	}
	
	/**
	 * 查询角色和对应 的权限
	 */
	@Override
	public List<RoleAndPermissionDto> queryRoleAndPermission(Long id) {
		// TODO Auto-generated method stub
		return roleMapper.queryRoleAndPermission(id);
	}
	
	/**
	 * 查询记录数
	 */
	@Override
	public int queryRoleCount() {
		// TODO Auto-generated method stub
		return roleMapper.queryRoleCount();
	}
	
	/**
	 * 插入角色数据
	 */
	@Override
	public int insertRole(RoleEntity roleEntity) {
		// TODO Auto-generated method stub
		// 插入日志
		try {
			SysLogUtil sysLogsUtil = new SysLogUtil();
			sysLogsUtil.logSave("角色管理", 
					"插入角色："+roleEntity.getRoleName(),
					"添加");
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return roleMapper.insertRole(roleEntity);
	}

	/**
	 * 往role和permission的中间表插入全部的权限
	 */
	@Override
	public int insertRoleAndPermisson() {
		// TODO Auto-generated method stub
		return roleMapper.insertRoleAndPermission();
	}

	@Override
	public int deleteRoleById(Object roleId) {
		// TODO Auto-generated method stub
		// 插入日志
		try {
			SysLogUtil sysLogsUtil = new SysLogUtil();
			sysLogsUtil.logSave("角色管理", 
					"通过ID"+roleId+"删除角色",
					"删除");
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return roleMapper.deleteRoleById(roleId);
	}

	@Override
	public int deleteRolePermissionById(Object roleId) {
		// TODO Auto-generated method stub
		// 删除sys_role_user中含有的role名
		roleMapper.deleteRoleAndUserById(roleId);
		return roleMapper.deleteRolePermissionById(roleId);
	}

	@Override
	public int updateRoleById(RoleEntity roleEntity) {
		// TODO Auto-generated method stub
		// 插入日志
		try {
			SysLogUtil sysLogsUtil = new SysLogUtil();
			sysLogsUtil.logSave("角色管理", 
					"更新角色："+roleEntity.getRoleName()+"对应的权限。",
					"更新");
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return roleMapper.updateRoleById(roleEntity);
	}

	@Override
	public int updateRolePermission(List<PermissionEntity> pList) {
		// TODO Auto-generated method stub
		return roleMapper.updateRolePermission(pList);
	}

	@Override
	public RoleEntity queryRoleByRoleName(RoleEntity roleEntity) {
		// TODO Auto-generated method stub
		return roleMapper.queryRoleByRoleName(roleEntity);
	}

	@Override
	public List<RoleEntity> queryAllRoles1() {
		// TODO Auto-generated method stub
		return roleMapper.queryAllRoles1();
	}

	@Override
	public int InsertRoleAndUser() {
		// TODO Auto-generated method stub
		return roleMapper.InsertRoleAndUser();
	}

}
