package com.mh.eems.service.impl;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.mh.eems.entity.UsageExceptionEntity;
import com.mh.eems.mapper.UsageExceptionMapper;
import com.mh.eems.service.UsageExceptionService;
/**
 *  用量异常查询实现类
 * @author chison
 *
 */
@Primary
@Service
public class UsageExceptionServiceImpl implements UsageExceptionService {

	@Autowired
	private UsageExceptionMapper usageExceptionMapper;
	
	
	/***/
	@Override
	public List<UsageExceptionEntity> queryException(UsageExceptionEntity param) {
		Map<String, Object> map=new HashMap<String, Object>();
		map.put("starTime", param.getStarTime());
		map.put("endTime", param.getEndTime());
		map.put("tableStarTime", param.getTableStarTime());
		map.put("tableEndTime", param.getTableEndTime());
		map.put("searchType","usage");
		map.put("page", param.getPage());
		map.put("limit", param.getLimit());
		map.put("areaName", param.getAreaName());
		map.put("level", param.getLevel());
		map.put("ratePercent", null);
		map.put("resultCount", 0);
		map.put("usageType", param.getUsageType());
		
		List<UsageExceptionEntity> lists=
			usageExceptionMapper.queryException(map);
		if(lists.size()>0) {
			lists.get(0).setCount((int)map.get("resultCount"));
		}
		return lists;
//		List<UsageExceptionEntity> lists=
//				usageExceptionMapper.queryException(map);
//		System.out.println("户数"+(Integer)map.get("resultCount"));
//		List<UsageExceptionEntity> result=new ArrayList<UsageExceptionEntity>();
//		System.out.println("结果集个数："+lists.size());
//		if(lists.size()!=0) {
//			/**连续累计个数最大值*/
//			int x=0;
//			/**每一次判断累计个数*/
//			int y=1;
//			/**相同户号个数*/
//			int houseCount=1;
//			/**不相同户号总和*/
//			int houseSum=0;
//			System.out.println("第一条数："+((param.getPage()-1)*param.getLimit()+1));
//			//遍历结果集
//			for (int i = 0; i < lists.size(); i++) {
//				if(houseSum==((param.getPage()-1)*param.getLimit())) {
////					if(i<lists.size()-1) {
//						//根据户号判断是否进入比较				
//						if(i<lists.size()-1 && lists.get(i).getHouseNum().equals(lists.get(i+1).getHouseNum())) {
//							//根据page和limit跳出判断
//							
//							//判断前后值是否都为0，累加个数
//							if(Double.doubleToLongBits(lists.get(i).getCalcFlow())==0 && 
//									Double.doubleToLongBits(lists.get(i+1).getCalcFlow())==0) {
//								y++;
//							}else {
//								if(x<y) {
//									x=y;
//									y=1;
//								}else {
//									y=1;
//								}
//							}
//							houseCount++;
//						}else {
//							UsageExceptionEntity entity=new UsageExceptionEntity();
//							entity.setCount((Integer)map.get("resultCount"));
//							System.out.println(i);
//							System.out.println("houseCount:"+houseCount);
//							//为输出到界面的结果集赋值
//							entity.setAreaName(lists.get(i).getAreaName());
//							entity.setBuilding(lists.get(i).getBuilding());
//							entity.setCollectionNum(lists.get(i).getCollectionNum());
//							entity.setDeviceNum(lists.get(i).getDeviceNum());
//							entity.setHouseAddress(lists.get(i).getHouseAddress());
//							entity.setHouseNum(lists.get(i).getHouseNum());
//							String rate=new DecimalFormat("0.00").format((float)x/houseCount);
//							entity.setRate(rate);
//							System.out.println("比例："+(int)(Double.parseDouble(rate)*100));
//							if((int)(Double.parseDouble(rate)*100)<=50) {
//								//正常用水范围
//								entity.setStatus("正常用水");
//							}else if((int)(Double.parseDouble(rate)*100)>50 && (int)(Double.parseDouble(rate)*100)<=90) {
//								entity.setStatus("间歇用水");
//							}else {
//								entity.setStatus("长期不用水");
//							}
//							
//							houseCount=1;
//							x=0;
//							y=1;
//							System.out.println("用户状态："+param.getUsageType());
//							//根据查询条件删除不需要的使用类型
//							if(param.getUsageType().equals("1")) {
//								//删除状态不为正常用水的数据
//								if(entity.getStatus()=="正常用水") {
//									result.add(entity);
//								}
//							}else if(param.getUsageType().equals("2")) {
//								if(entity.getStatus()=="间歇用水") {
//									result.add(entity);
//								}
//							}else if(param.getUsageType().equals("3")) {
//								if(entity.getStatus()=="长期不用水") {
//									result.add(entity);
//								}
//							}else {
//								result.add(entity);
//							}
//							//分页
//							//(page-1)*limit
//							if(result.size()==param.getLimit()) {
//								break;
//							}
//						}
////					}
//				}else {
//					if(lists.get(i).getHouseNum().equals(lists.get(i+1).getHouseNum())) {
//						continue;
//					}
//					houseSum++;
//				}
//			}
//		}
		
	}

	@Override
	public List<UsageExceptionEntity> homeException() {
		List<UsageExceptionEntity> lists=new ArrayList<UsageExceptionEntity>();
		UsageExceptionEntity param=new UsageExceptionEntity();
		UsageExceptionEntity usageException=
			usageExceptionMapper.homeException();
		param.setStatusType("正常用水");
		param.setHouseNumCount(usageException.getTotal()-usageException.getExceptionCount());
		lists.add(param);
		UsageExceptionEntity param1=new UsageExceptionEntity();
		param1.setStatusType("异常用水");
		param1.setHouseNumCount(usageException.getExceptionCount());
		lists.add(param1);
//		if(lists.size()>0) {
//			param.setStatusType("正常用水");
//			System.out.println(lists.get(0).getHouseNumCount());
//			System.out.println((int)map.get("resultCount")-lists.get(0).getHouseNumCount());
//			param.setHouseNumCount((int)map.get("resultCount")-lists.get(0).getHouseNumCount());
//			System.out.println(map.get("resultCount"));
//			lists.add(param);
////			lists.get(0).setCount((int)map.get("resultCount"));
//		}
		return lists;
	}

	@Override
	public List<UsageExceptionEntity> percentException(UsageExceptionEntity param) {
		Map<String, Object> map=new HashMap<String, Object>();
		map.put("starTime", param.getStarTime());
		map.put("endTime",param.getEndTime());
		map.put("tableStarTime", param.getTableStarTime());
		map.put("tableEndTime",param.getTableEndTime());
		map.put("searchType", "rate");
		map.put("page", param.getPage());
		map.put("limit", param.getLimit());
		map.put("areaName", param.getAreaName());
		map.put("level", param.getLevel());
		map.put("ratePercent", param.getPercent());
		map.put("resultCount", 0);
		map.put("usageType", param.getUsageType());
		
		List<UsageExceptionEntity> lists=usageExceptionMapper.percentException(map);
		if(lists.size()>0) {
			lists.get(0).setCount((int)map.get("resultCount"));
		}
		return lists;
	}
	


}
