package com.mh.eems.service.impl;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Primary;
import org.springframework.stereotype.Service;

import com.mh.eems.entity.NowUsageEntity;
import com.mh.eems.entity.UsageEntity;
import com.mh.eems.mapper.UsageMapper;
import com.mh.eems.service.UsageService;
/**
 * 用量管理实现类
 * @author chison
 *
 */
@Primary
@Service
public class UseageServiceImpl implements UsageService{

	
	@Autowired(required = false)
	private UsageMapper usageMapper;
	
	@Override
	public List<UsageEntity> queryAllUsage(UsageEntity usageEntity) {
		Map<String, Object> map=new HashMap<String, Object>();
		map.put("TimeType", usageEntity.getTimeType());
		map.put("starTime", usageEntity.getStarTime());
		map.put("endTime", usageEntity.getEndTime());
		map.put("houseNum", usageEntity.getHouseNum());
		map.put("houseAddress", usageEntity.getHouseAddress());
		map.put("limit", usageEntity.getLimit());
		map.put("page", usageEntity.getPage());
		map.put("areaName", usageEntity.getAreaName());
		map.put("level", usageEntity.getLevel());
		map.put("resultCount", 0);
		List<UsageEntity> lists=usageMapper.queryAllUsage(map);
		if(lists.size()!=0) {
			lists.get(0).setTotal((Integer)map.get("resultCount"));
		}
		return lists;
	}

	@Override
	public List<UsageEntity> usageCount() {
		String time=new SimpleDateFormat("yyyy-MM-dd").format(new Date());
		String tableName="wt_day"+new SimpleDateFormat("yyyyMM").format(new Date());
		List<UsageEntity> lists=
			usageMapper.usageCount(time, tableName);
		if(lists.size()==0) {
			List<String> areas=usageMapper.queryArea();
			if(areas.size()>0) {
				for (String area : areas) {
					UsageEntity e1=new UsageEntity();
					e1.setCalcFlow(0.0);
					e1.setHouseNum(area);
					lists.add(e1);
				}
			}
		}
		return lists;
	}

	@Override
	public List<NowUsageEntity> nowUsage(NowUsageEntity nowUsageEntity) {
		Map<String, Object> map=new HashMap<String, Object>();
		map.put("level_name", nowUsageEntity.getAreaName());
		map.put("level_id", nowUsageEntity.getLevel());
		map.put("house_num", nowUsageEntity.getHouseNum());
		map.put("page", nowUsageEntity.getPage());
		map.put("limit", nowUsageEntity.getLimit());
		map.put("status", nowUsageEntity.getStatus());
		map.put("count", 0);
		
		List<NowUsageEntity> lists=usageMapper.nowUsage(map);
		if(lists.size()>0) {
			lists.get(0).setCount((Integer)map.get("count"));
		}
		return lists;
	}
	
	
	
}
