package com.mh.eems.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.context.ApplicationContext;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.DValueEntity;
import com.mh.eems.service.DValueService;

/**
 * 
 * @ClassName:  DValueUtil   
 * @Description:TODO(总分差值工具类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月14日 下午5:44:30   
 *
 */
public class DValueUtil {
	
	// 添加之后能够对mapper调用
	private ApplicationContext applicationContext = SpringUtil.getApplicationContext();

	private DValueService dValueService = applicationContext.getBean(DValueService.class);
	
	// 获取查询图表信息数据
	public Object queryAllChart(String startTime,String endTime,String queryType,String nodeName,Integer level, Integer page, Integer limit) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("startTime", startTime);
		map.put("endTime", endTime);
		map.put("queryType", queryType);
		map.put("nodeName", nodeName);
		map.put("level", level);
		map.put("page", page);
		map.put("limit", limit);
		List<DValueEntity> list = dValueService.queryDValue(map);
		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		int count = (int) map.get("result_count");
		
		int b = 0;
		for (DValueEntity dValueEntity : list) {
			int a = list.indexOf(dValueEntity);
			if (a == list.size()-1) {
				b=a;
			} 
		}
		list.remove(b);
		
		// 查询关于图表的数据
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("code", 200);
		jsonObject.put("msg", "查询成功");
		jsonObject.put("count", count-1);				// 减一是减去合计行
		JSONObject dataJson = new JSONObject();
		
		// 把查询出来的片区名放入数组中
		List<String> nameList = new ArrayList<String>();
		nameList.add("总表值");
		nameList.add("分表值");
		
		// 把查询出来的时间值放入数组中
		List<String> timeList = new ArrayList<String>();
		for (DValueEntity dValueEntity : list) {
			if (!timeList.contains(dValueEntity.getCurTime())) {
				timeList.add(dValueEntity.getCurTime().toString());
			}
		}
//					System.out.println("timeList大小："+timeList.size()+";"+timeList.toString());
		dataJson.put("times", timeList);
		
		// 把查询出来的计算值放入数组中
		JSONArray series = new JSONArray();
		for (int i = 0; i < nameList.size(); i++) {
			JSONObject seriesJson = new JSONObject();
			List<Float> data = new ArrayList<Float>();
			for (DValueEntity peakValleyEntity : list) {
				if (nameList.get(i).equals("总表值")) {
					data.add(Float.parseFloat(peakValleyEntity.getCalcFlow().toString()));
				} else if (nameList.get(i).equals("分表值")) {
					data.add(Float.parseFloat(peakValleyEntity.getBranchUsed().toString()));
				} 
			}
			seriesJson.put("name", nameList.get(i));
			seriesJson.put("type", "bar");
			seriesJson.put("data", data);
//						System.out.println("nameList的值："+nameList.get(i)+";data数组大小："+data.size()+";"+data.toString());
//						System.out.println(seriesJson.toJSONString());
			series.add(seriesJson);
		}
		dataJson.put("series", series);
		
		jsonObject.put("data", dataJson);
		System.out.println(jsonObject.toJSONString());
		return jsonObject;
	}

}
