package com.mh.eems.util;

import java.util.Iterator;
import java.util.List;

import org.springframework.context.ApplicationContext;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.DataEntity;
import com.mh.eems.entity.DeviceData;
import com.mh.eems.service.DeviceDataService;

/**
 * 
 * @ClassName: FastJsonUtil
 * @Description:TODO(解析json数值)
 * @author: 铭汉科技—LJF
 * @date: 2019年6月13日 上午9:27:41
 *
 */
public class FastJsonUtil {

	// 添加之后能够对mapper调用
	public static ApplicationContext applicationContext = SpringUtil.getApplicationContext();

	private static DeviceDataService deviceDataService = applicationContext.getBean(DeviceDataService.class);

	public static String analysisFastJson(String receiveData) {
		String resultStr = "";
		try {
			DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
			// DBIdentifier.setProjectCode("本地NB网络电表");

			DataEntity dataEntity = JSON.parseObject(receiveData, new TypeReference<DataEntity>() {
			});
			// Teacher teacher1 = JSON.parseObject(COMPLEX_JSON_STR, new
			// TypeReference<Teacher>() {});//因为JSONObject继承了JSON，所以这样也是可以的
//			Integer state = dataEntity.getState();
//			String ProjectCode = dataEntity.getProjectCode();
			List<DeviceData> deviceDatas = dataEntity.getData();
//			for (DeviceData deviceData : deviceDatas) {
//				System.out.println("设备ID：" + deviceData.getDeviceID() + "\n" + "最新采集时间：" + deviceData.getCollectTime()
//						+ "\n" + "脉冲常数：" + deviceData.getPulseData() + "\n" + "读数：" + deviceData.getCollectData()
//						+ "\n");
//			}
			// 判断是否数据库已存在相同的数据。存在则进行删除
			Iterator<DeviceData> it = deviceDatas.iterator();
			while (it.hasNext()) {
				DeviceData x = it.next();
				// 查询数据库数据，看是否已存在，存在返回 1，删除list，不存在 返回 0
				int i = deviceDataService.checkWtHistory(x);
				if (i >= 1) {
					it.remove();
				}
			}
			// 判断list大小，如果为零 ，不进行操作，大于零，则插入数据库
			Integer size = deviceDatas.size();
			System.out.println("List的大小：" + deviceDatas.size());
			if (size > 0) {
				for (DeviceData deviceData : deviceDatas) {
					System.out.println("设备ID：" + deviceData.getDeviceID() + "\n" + "最新采集时间："
							+ deviceData.getCollectTime() + "\n" + "脉冲常数：" + deviceData.getPulseData() + "\n" + "读数："
							+ deviceData.getCollectData() + "\n");
				}
				int j = deviceDataService.insertAllWtData(deviceDatas);
				if (j != 0) {
					resultStr = "success";
				}
			}
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
			resultStr = "fail";
		}
		return resultStr;
	}

//	public static void main(String[] args) {
//		String string = "{\r\n" + "    \"State\":0,\r\n" + "    \"ProjectCode\":\"gzmh\",\r\n" + "    \"Data\":[\r\n"
//				+ "        {\r\n" + "            \"DeviceID\":\"19045040\",\r\n"
//				+ "            \"CollectTime\":\"2019-06-13 09:42:32\",\r\n" + "            \"PulseData\":\"0\",\r\n"
//				+ "            \"VolData\":\"3.59\",\r\n" + "            \"CollectData\":\"57.0\"\r\n"
//				+ "        },\r\n" + "        {\r\n" + "            \"DeviceID\":\"19045032\",\r\n"
//				+ "            \"CollectTime\":\"2019-06-13 09:40:33\",\r\n" + "            \"PulseData\":\"0\",\r\n"
//				+ "            \"VolData\":\"3.6\",\r\n" + "            \"CollectData\":\"163.0\"\r\n"
//				+ "        },\r\n" + "        {\r\n" + "            \"DeviceID\":\"19045038\",\r\n"
//				+ "            \"CollectTime\":\"2019-06-13 09:40:24\",\r\n" + "            \"PulseData\":\"0\",\r\n"
//				+ "            \"VolData\":\"3.57\",\r\n" + "            \"CollectData\":\"131.0\"\r\n"
//				+ "        }\r\n" + "    ]\r\n" + "}";
//		System.out.println(analysisFastJson(string));
//	}

}
