package com.mh.eems.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.context.ApplicationContext;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.PeakValleyEntity;
import com.mh.eems.service.PeakValleyService;

/**
 * 
 * @ClassName:  PeckValleyUtil   
 * @Description:TODO(峰谷值接口工具类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月13日 下午2:31:57   
 *
 */
public class PeckValleyUtil {
	
	// 添加之后能够对mapper调用
	private ApplicationContext applicationContext = SpringUtil.getApplicationContext();

	private PeakValleyService peakValleyService = applicationContext.getBean(PeakValleyService.class);
	
	// 获取查询图表信息数据
	public Object queryAllChart(String curDate, Integer page, Integer limit, Integer level, String name) {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("code", level);
		map.put("name", name);
		map.put("cur_date", curDate);
		map.put("page", page);
		map.put("limit", limit);
		List<PeakValleyEntity> list =peakValleyService.queryPeakValleyByMap(map);
		int count = (int) map.get("result_count");
		
		// 全查询图标数据
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("code", 200);
		jsonObject.put("msg", "查询成功");
		jsonObject.put("count", count);
		
		JSONObject dataJson = new JSONObject();
		// 把查询出来的片区名放入数组中
		List<String> nameList = new ArrayList<String>();
		for (PeakValleyEntity peakValleyEntity : list) {
			if (!nameList.contains(peakValleyEntity.getName())) {
				nameList.add(peakValleyEntity.getName().toString());
			}
		}
		
		// 把查询出来的时间值放入数组中
		List<String> timeList = new ArrayList<String>();
		for (PeakValleyEntity peakValleyEntity : list) {
			if (!timeList.contains(peakValleyEntity.getCurTime())) {
				timeList.add(peakValleyEntity.getCurTime().toString());
			}
		}
		dataJson.put("times", timeList);
		
		// 把查询出来的计算值放入数组中
		JSONArray series = new JSONArray();
		for (int i = 0; i < nameList.size(); i++) {
			JSONObject seriesJson = new JSONObject();
			List<Float> data = new ArrayList<Float>();
			for (PeakValleyEntity peakValleyEntity : list) {
				if (peakValleyEntity.getName().equals(nameList.get(i))) {
					data.add(Float.parseFloat(peakValleyEntity.getCalcFlow().toString()));
				}
			}
			seriesJson.put("name", nameList.get(i));
			seriesJson.put("type", "line");
			seriesJson.put("smooth", true);
			seriesJson.put("data", data);
			series.add(seriesJson);
		}
		dataJson.put("series", series);
		
		jsonObject.put("data", dataJson);
		System.out.println(jsonObject.toJSONString());
		return jsonObject;
	}

}
