package com.mh.eems.util;

import org.springframework.beans.BeansException;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.core.env.Environment;
import org.springframework.stereotype.Component;

/**
 * 
 * @ClassName:  SpringUtils   
 * @Description:TODO(spring获取bean类型)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年6月14日 下午4:05:44   
 *
 */
@Component
public class SpringUtil implements ApplicationContextAware{
	
	private static ApplicationContext applicationContext = null;

	@Override
	public void setApplicationContext(ApplicationContext arg0) throws BeansException {
		// TODO Auto-generated method stub
		if (SpringUtil.applicationContext == null) {
			SpringUtil.applicationContext = arg0;
		}
	}
	
	// 获取applicationContext
	public static ApplicationContext getApplicationContext() {
		return applicationContext;
	}
	
	// 通过Name获取Bean
	public static Object getBean(String name) {
		return getApplicationContext().getBean(name);
	}
	
	// 通过class获取Bean
	public static <T> T getBean(Class<T> claszz) {
		return getApplicationContext().getBean(claszz);
	}
	
	// 通过name，以及claszz返回指定的bean
	public static <T> T getBean(String name,Class<T> clazz) {
		return getApplicationContext().getBean(name,clazz);
	}
	
	public static String getProperty(String key) {
		return applicationContext.getBean(Environment.class).getProperty(key);
	}

}
