package com.mh.eems.util;

import java.util.List;

import org.apache.shiro.SecurityUtils;
import org.apache.shiro.session.Session;
import org.apache.shiro.subject.Subject;

import com.mh.eems.constants.UserConstants;
import com.mh.eems.entity.PermissionEntity;
import com.mh.eems.entity.SysUserEntity;

public class SysUserUtil {

	public static SysUserEntity getCurrentUser() {
		SysUserEntity user = (SysUserEntity) getSession().getAttribute(UserConstants.LOGIN_USER);

		return user;
	}

	public static void setUserSession(SysUserEntity user) {
		getSession().setAttribute(UserConstants.LOGIN_USER, user);
	}

	@SuppressWarnings("unchecked")
	public static List<PermissionEntity> getCurrentPermissions() {
		List<PermissionEntity> list = (List<PermissionEntity>) getSession().getAttribute(UserConstants.USER_PERMISSIONS);

		return list;
	}

	public static void setPermissionSession(List<PermissionEntity> list) {
		getSession().setAttribute(UserConstants.USER_PERMISSIONS, list);
	}

	public static Session getSession() {
		Subject currentUser = SecurityUtils.getSubject();
		Session session = currentUser.getSession();

		return session;
	}
}
