package com.mh.eems.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.context.ApplicationContext;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.UsageAnalysisEntity;
import com.mh.eems.service.UsageAnalysisService;

/**
 * 
 * @ClassName:  UsageAnalysisUtil   
 * @Description:TODO(使用量分析工具类)   
 * @author: 铭汉科技—LJF 
 * @date:   2019年8月19日 上午9:40:02   
 *
 */
public class UsageAnalysisUtil {
	
	// 添加之后能够对mapper调用
	private ApplicationContext applicationContext = SpringUtil.getApplicationContext();

	private UsageAnalysisService usageAnalysisService = applicationContext.getBean(UsageAnalysisService.class);
	
	// 查询首页各个片区季度柱状图
	public Object queryChart() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("level", 0);
		map.put("nodeName", null);
		map.put("time", null);
		map.put("page", null);
		map.put("limit", null);
		List<UsageAnalysisEntity> list =usageAnalysisService.queryUsageAnalysisByMap(map);
		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		int count = (int) map.get("result_count");
		
		// 查询关于图表的数据
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("code", 200);
		jsonObject.put("msg", "查询成功");
		jsonObject.put("count", count);			
		JSONObject dataJson = new JSONObject();
		
		// 把查询出来的片区名放入数组中
		List<String> nameList = new ArrayList<String>();
		for (UsageAnalysisEntity usageAnalysisEntity : list) {
			if (!nameList.contains(usageAnalysisEntity.getName())) {
				nameList.add(usageAnalysisEntity.getName().toString());
			}
		}
		
		// 把查询出来的时间值放入数组中
		List<String> timeList = new ArrayList<String>();
		for (UsageAnalysisEntity usageAnalysisEntity : list) {
			if (!timeList.contains(usageAnalysisEntity.getTime())) {
				timeList.add(usageAnalysisEntity.getTime().toString());
			}
		}
//					System.out.println("timeList大小："+timeList.size()+";"+timeList.toString());
		dataJson.put("times", timeList);
		
		// 把查询出来的计算值放入数组中
		JSONArray series = new JSONArray();
		for (int i = 0; i < nameList.size(); i++) {
			JSONObject seriesJson = new JSONObject();
			List<Float> data = new ArrayList<Float>();
			for (UsageAnalysisEntity usageAnalysisEntity : list) {
				if (usageAnalysisEntity.getName().equals(nameList.get(i))) {
					data.add(Float.parseFloat(usageAnalysisEntity.getTotalUsed().toString()));
				}
			}
			seriesJson.put("name", nameList.get(i));
			seriesJson.put("type", "bar");
//			seriesJson.put("smooth", true);
			seriesJson.put("data", data);
			series.add(seriesJson);
		}
		dataJson.put("series", series);
		
		jsonObject.put("data", dataJson);
		System.out.println(jsonObject.toJSONString());
		return jsonObject;
	}

}
