/**
 * 导出接口数据的样例
 * 
 * @return {[type]} [description]
 */
function exportApiDemo() {
	layui.use([ 'jquery', 'excel', 'layer' ], function() {
		var $ = layui.jquery
		var layer = layui.layer
		var excel = layui.excel

		// 模拟从后端接口读取需要导出的数据
		$.ajax({
			// 请求地址,此处数据为本地加载
			url : '/query/lastData',
			// 请求方式
			method : "post",
			// 请求内容类型
//			contentType : "application/x-www-form-urlencoded",
			// 数据类型
			dataType : "json",
			success : function(data) {
				console.log(data)
				// 重点！！！如果后端给的数据顺序和映射关系不对，请执行梳理函数后导出
				data = excel.filterExportData(data, {
					userNo : 'userNo',
					meterID : 'meterID',
					houseNo : 'houseNo',
					lastValue : 'lastValue',
					lastDate : 'lastDate'
				})
				// 重点2！！！一般都需要加一个表头，表头的键名顺序需要与最终导出的数据一致
				data.unshift({
					userNo : "户号",
					meterID : "NB设备ID号",
					houseNo : '房号',
					lastValue : '最新读数',
					lastDate : '最新采集时间'
				})

				var timestart = Date.now()
				excel.exportExcel({
					sheet1 : data
				}, '最新读数.xlsx', 'xlsx')
				var timeend = Date.now()

				var spent = (timeend - timestart) / 1000
				layer.alert('单纯导出耗时 ' + spent + ' s')
			},
			error : function() {
				layer.alert('获取数据失败，请检查是否部署在本地服务器环境下')
			}
		})
	})
}