package com.mh.eems;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.DValueEntity;
import com.mh.eems.service.DValueService;

public class DValueTest extends SpringTestCase {
	
	@Autowired 
	private DValueService dValueService;
	
	@Test
	public void queryDValues() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("startTime", "2019-07-22 10:00:00");
		map.put("endTime", "2019-07-22 13:00:00");
		map.put("queryType", "hour");
		map.put("nodeName", "星辰大厦");
		map.put("level", 4);
		map.put("page", 1);
		map.put("limit", 10);
		List<DValueEntity> list = dValueService.queryDValue(map);
		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		int count = (int) map.get("result_count");
		
		// 查询关于图表的数据
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("code", 200);
		jsonObject.put("msg", "查询成功");
		jsonObject.put("count", count);
		JSONObject dataJson = new JSONObject();
		
		// 把查询出来的片区名放入数组中
		List<String> nameList = new ArrayList<String>();
		nameList.add("总表值");
		nameList.add("分表值");
//		for (DValueEntity dValueEntity : list) {
//			if (!nameList.contains(dValueEntity.getName())) {
//				nameList.add(dValueEntity.getName().toString());
//			}
//		}
//				System.out.println("nameList大小："+nameList.size()+";"+nameList.toString());
		
		// 把查询出来的时间值放入数组中
		List<String> timeList = new ArrayList<String>();
		for (DValueEntity dValueEntity : list) {
			if (!timeList.contains(dValueEntity.getCurTime())) {
				timeList.add(dValueEntity.getCurTime().toString());
			}
		}
//				System.out.println("timeList大小："+timeList.size()+";"+timeList.toString());
		dataJson.put("times", timeList);
		
		// 把查询出来的计算值放入数组中
		JSONArray series = new JSONArray();
		for (int i = 0; i < nameList.size(); i++) {
			JSONObject seriesJson = new JSONObject();
			List<Float> data = new ArrayList<Float>();
			for (DValueEntity peakValleyEntity : list) {
				if (nameList.get(i).equals("总表值")) {
					data.add(Float.parseFloat(peakValleyEntity.getCalcFlow().toString()));
				} else if (nameList.get(i).equals("分表值")) {
					data.add(Float.parseFloat(peakValleyEntity.getBranchUsed().toString()));
				} 
			}
			seriesJson.put("name", nameList.get(i));
			seriesJson.put("type", "bar");
			seriesJson.put("data", data);
//					System.out.println("nameList的值："+nameList.get(i)+";data数组大小："+data.size()+";"+data.toString());
//					System.out.println(seriesJson.toJSONString());
			series.add(seriesJson);
		}
		dataJson.put("series", series);
		
		jsonObject.put("data", dataJson);
		System.out.println(jsonObject.toJSONString());
	}

	@Test
	public void test123132(){
		System.out.println("test");
	}

}
