package com.mh.eems;
import java.io.*;
import java.util.List;
import com.alibaba.excel.EasyExcelFactory;
import com.alibaba.excel.metadata.Sheet;
import com.mh.eems.util.StringUtil;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.dto.ResultDto;
import com.mh.eems.entity.HistoryByHandEntity;
import com.mh.eems.service.HistoryByHandService;
import org.springframework.boot.test.context.SpringBootTest;
public class HistoryTest extends SpringTestCase {

    @Autowired
    private HistoryByHandService historyByHandService;

    @Test
    public void adde() throws IOException {
        InputStream inputStream = new FileInputStream("E:\\test\\wt_history_hand.xlsx");
        BufferedInputStream bufferedInputStream = new BufferedInputStream(inputStream);
        List<Object> data = EasyExcelFactory.read(bufferedInputStream, new Sheet(1, 1, HistoryByHandEntity.class));        // 第几张工作表，第几行开始，javamodel
        inputStream.close();
        StringUtil stringUtil = new StringUtil();
      //  stringUtil.print(data);
       HistoryByHandEntity  entity  = (HistoryByHandEntity) data.get(0);
        System.out.println("-----------------------");
        System.out.println(entity.toString());
        System.out.println("读取完毕");

    }

    @Test
    public void test() {
        System.out.println("读取完毕");
    }

    // 添加记录值
    @Test
    public void addHistory() {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        HistoryByHandEntity historyByHandEntity = new HistoryByHandEntity();
        historyByHandEntity.setHouseNum("1705");
        historyByHandEntity.setDeviceNum("");
        historyByHandEntity.setCollectionNum("0000001998");
        historyByHandEntity.setCurFlow(14.0);
        historyByHandEntity.setCurDate("2019-08-09 14:00:00");
        ResultDto resultDto = historyByHandService.insertHistory(historyByHandEntity, 1);
        System.out.println("返回值：" + resultDto.getResult().toString());
    }

    // 修改记录值
    @Test
    public void updateHistory() {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);

        HistoryByHandEntity historyByHandEntity = new HistoryByHandEntity();
        historyByHandEntity.setHouseNum("1705");
        historyByHandEntity.setDeviceNum("");
        historyByHandEntity.setCollectionNum("0000001998");
        historyByHandEntity.setCurFlow(15.0);
        historyByHandEntity.setCurDate("2019-08-09 14:00:00");
        historyByHandEntity.setId(1);
        String resultDto = historyByHandService.updateHistory(historyByHandEntity);
        System.out.println("返回值：" + resultDto);

    }

    // 查询历史记录
    @Test
    public void queryHistory() {
        DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
        List<HistoryByHandEntity> historyByHandEntities = historyByHandService.queryHistorys(1, 10);
        System.out.println(JSON.toJSONString(historyByHandEntities, SerializerFeature.PrettyFormat, SerializerFeature.WriteMapNullValue));
    }

//	// 删除记录值
//	@Test
//	public void deleteHistory() {
//		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
//		int a = historyByHandService.deleteHistory(1);
//		System.out.println(a);
//	}


}
