package com.mh.eems;

import com.alibaba.fastjson.JSONObject;
import org.junit.Test;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.client.RestTemplate;

import java.io.*;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

/**
 * @Classname HttpDoPost
 * @Description TODO
 * @Date 2020-07-22 10:10
 * @Created by NING MEI
 */
@SpringBootTest
public class HttpDoPost {
    @Test
    public void testPush() {
//        MultiValueMap<String, Object> data = null;
        JSONObject json = new JSONObject();
        JSONObject first = new JSONObject();
        JSONObject keyword1 = new JSONObject();
        JSONObject keyword2 = new JSONObject();
        JSONObject keyword3 = new JSONObject();
        JSONObject remark = new JSONObject();
        JSONObject jsonObject = new JSONObject();
        MultiValueMap<String, Object> map = new LinkedMultiValueMap<>();
        String templateId = "EVR8yltNBbYtqsxpZt7CnRvuEt-IENRZz02puAbe18E";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        first.put("value", "每日统计报表");
        first.put("color", "#173177");
        json.put("first", first);
        keyword1.put("value", "网关和抄表失败");
        keyword1.put("color", "#173177");
        json.put("keyword1", keyword1);
        keyword2.put("value", sdf.format(new Date()));
        keyword2.put("color", "#173177");
        json.put("keyword2", keyword2);
        keyword3.put("value", sdf.format(new Date()));
        keyword3.put("color", "#173177");
        json.put("keyword3", keyword3);
        remark.put("value", "网关失败：12 抄表失败：3200 \n" +
                "网关失败：12 抄表失败：3200\n" +
                "网关失败：12 抄表失败：3200\n" +
                "网关失败：12 抄表失败：3200");
        json.put("remark", remark);
        map.add("key", "minghan2020");
        map.add("tel", "15278773313");
        map.add("tplid", templateId);
        map.add("data", json.toJSONString());
        System.out.println(map.toString());
        RestTemplate rest = new RestTemplate();
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_FORM_URLENCODED);
        HttpEntity<MultiValueMap<String, Object>> request = new HttpEntity<>(map, headers);
        ResponseEntity<String> response;
        response = rest.postForEntity("http://wushuhe.w.ratuo.com.cn/api/index/SendNotifyMessage", request, String.class);
        System.out.println(response);
    }

    @Test
    public void test() {
        Map<String, Object> first = new HashMap<>();
        first.put("value", "每日统计报表");
        first.put("color", "#173177");
        Map<String, Object> keyword1 = new HashMap<>();
        keyword1.put("value", "网关和抄表失败");
        keyword1.put("color", "#173177");
        Map<String, Object> keyword2 = new HashMap<>();
        keyword2.put("value", "2019-12-09");
        keyword2.put("color", "#173177");
        Map<String, Object> keyword3 = new HashMap<>();
        keyword3.put("value", "自动运算");
        keyword3.put("color", "#173177");
        Map<String, Object> remark = new HashMap<>();
        remark.put("value", "网关失败：12 抄表失败：3200 \n" +
                "网关失败：12 抄表失败：3200\n" +
                "网关失败：12 抄表失败：3200\n" +
                "网关失败：12 抄表失败：3200");
        remark.put("color", "#173177");
        Map<String, Object> data = new HashMap<>();
        data.put("first", first);
        data.put("keyword1", keyword1);
        data.put("keyword2", keyword2);
        data.put("keyword3", keyword3);
        data.put("remark", remark);
        JSONObject object = new JSONObject();
        object.put("key", "minghan2020");
        object.put("tel", "15278773313");
        object.put("tplid", "EVR8yltNBbYtqsxpZt7CnRvuEt-IENRZz02puAbe18E");
        object.put("data", data);
//        System.out.println(object.toJSONString());
//        Object obj =null;
//        String  httpurl="http://wushuhe.w.ratuo.com.cn/api/index/SendNotifyMessage";
//        RestTemplate
//       sendPost(httpurl,object.toJSONString());
        RestTemplate rest = new RestTemplate();
        HttpHeaders headers = new HttpHeaders();
        headers.setContentType(MediaType.APPLICATION_JSON);
        HttpEntity<JSONObject> request = new HttpEntity<>(object, headers);
        System.out.println(request.toString());
        ResponseEntity<String> response =
                rest.postForEntity("http://wushuhe.w.ratuo.com.cn/api/index/SendNotifyMessage", request, String.class);
        System.out.println(response);
    }

    //由于这类方法经常被用到，因此建议写在一个工具类里面，设置为静态方法，方便调用。
    //requestUrl表示请求链接
    public static String sendGet(String requestUrl) {
        StringBuffer buffer = null;

        try {
            // 建立连接
            URL url = new URL(requestUrl);
            HttpURLConnection httpUrlConn = (HttpURLConnection) url.openConnection();
            httpUrlConn.setDoInput(true);
            httpUrlConn.setRequestMethod("GET");

            // 获取输入流
            InputStream inputStream = httpUrlConn.getInputStream();
            InputStreamReader inputStreamReader = new InputStreamReader(inputStream, "utf-8");
            BufferedReader bufferedReader = new BufferedReader(inputStreamReader);

            // 读取返回结果
            buffer = new StringBuffer();
            String str = null;
            while ((str = bufferedReader.readLine()) != null) {
                buffer.append(str);
            }

            // 释放资源
            bufferedReader.close();
            inputStreamReader.close();
            inputStream.close();
            httpUrlConn.disconnect();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return buffer.toString();
    }

    //由于这类方法经常被用到，因此建议写在一个工具类里面，设置为静态方法，方便调用。
    //url表示请求链接，param表示json格式的请求参数
    public static String sendGet(String url, Object param) {
        String result = "";
        BufferedReader in = null;
        PrintWriter out = null;
        try {
            URL realUrl = new URL(url);
            // 打开和URL之间的连接
            URLConnection connection = realUrl.openConnection();
            connection.setDoOutput(true);
            // 建立实际的连接
            connection.connect();
            out = new PrintWriter(connection.getOutputStream());
            // 发送请求参数
            out.print(param);
            // 定义 BufferedReader输入流来读取URL的响应
            in = new BufferedReader(new InputStreamReader(
                    connection.getInputStream(), "UTF-8"));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
        } catch (Exception e) {
            System.out.println("发送GET请求出现异常！" + e);
            e.printStackTrace();
        }
        // 使用finally块来关闭输入流
        finally {
            try {
                if (in != null) {
                    in.close();
                }
            } catch (Exception e2) {
                e2.printStackTrace();
            }
        }
        System.out.println(result);
        return result;
    }

    //由于这类方法经常被用到，因此建议写在一个工具类里面，设置为静态方法，方便调用。
    //url表示请求链接，param表示json格式的请求参数
    public static String sendPost(String url, Object param) {
        PrintWriter out = null;
        BufferedReader in = null;
        String result = "";
        try {
            URL realUrl = new URL(url);
            // 打开和URL之间的连接
            URLConnection conn = realUrl.openConnection();
            // 设置通用的请求属性 注意Authorization生成
            // conn.setRequestProperty("Content-Type",
            // "application/x-www-form-urlencoded");
            // 发送POST请求必须设置如下两行
            conn.setDoOutput(true);
            conn.setDoInput(true);
            // 获取URLConnection对象对应的输出流
            out = new PrintWriter(new OutputStreamWriter(conn.getOutputStream(), "utf-8"));
            // 发送请求参数
            out.print(param);
            // flush输出流的缓冲
            out.flush();
            // 定义BufferedReader输入流来读取URL的响应
            in = new BufferedReader(
                    new InputStreamReader(conn.getInputStream(), "utf-8"));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
            System.out.println(result);
        } catch (Exception e) {
            System.out.println("发送 POST 请求出现异常！" + e);
            e.printStackTrace();
        }
        // 使用finally块来关闭输出流、输入流
        finally {
            try {
                if (out != null) {
                    out.close();
                }
                if (in != null) {
                    in.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return result;
    }
}
