package com.mh.eems;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.PeakValleyEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.mapper.PeakValleyMapper;
import com.mh.eems.service.PeakValleyService;

public class PeakValleyTest extends SpringTestCase {

	@Autowired
	private PeakValleyService peakValleyService;
	
	@Autowired
	private PeakValleyMapper peakValleyMapper;
	
	// 查询全部的结果集
	@Test
	public void queryPeakValley() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("code", 2);
		map.put("name", null);
		map.put("cur_date", "2019-07-22");
		map.put("page", null);
		map.put("limit", null);
		List<PeakValleyEntity> list =peakValleyMapper.queryPeakValleyByMap(map);
//		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		int count = (int) map.get("result_count");
//		System.out.println("总数目："+ count);
		
		// 全查询数据
		ResponseEntity<PeakValleyEntity> pEntity = new ResponseEntity<PeakValleyEntity>();
		pEntity.setCode(200);
		pEntity.setMsg("查询成功");
		pEntity.setCount(count);
		pEntity.setData(list);
		System.out.println(JSON.toJSONString(pEntity,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		
		// 全查询图标数据
		JSONObject jsonObject = new JSONObject();
		jsonObject.put("code", 200);
		jsonObject.put("msg", "查询成功");
		jsonObject.put("count", count);
		JSONObject dataJson = new JSONObject();
		
		// 把查询出来的片区名放入数组中
		List<String> nameList = new ArrayList<String>();
		for (PeakValleyEntity peakValleyEntity : list) {
			if (!nameList.contains(peakValleyEntity.getName())) {
				nameList.add(peakValleyEntity.getName().toString());
			}
		}
//		System.out.println("nameList大小："+nameList.size()+";"+nameList.toString());
		
		// 把查询出来的时间值放入数组中
		List<String> timeList = new ArrayList<String>();
		for (PeakValleyEntity peakValleyEntity : list) {
			if (!timeList.contains(peakValleyEntity.getCurTime())) {
				timeList.add(peakValleyEntity.getCurTime().toString());
			}
		}
//		System.out.println("timeList大小："+timeList.size()+";"+timeList.toString());
		dataJson.put("times", timeList);
		
		// 把查询出来的计算值放入数组中
		JSONArray series = new JSONArray();
		for (int i = 0; i < nameList.size(); i++) {
			JSONObject seriesJson = new JSONObject();
			List<Float> data = new ArrayList<Float>();
			for (PeakValleyEntity peakValleyEntity : list) {
				if (peakValleyEntity.getName().equals(nameList.get(i))) {
					data.add(Float.parseFloat(peakValleyEntity.getCalcFlow().toString()));
				}
			}
			seriesJson.put("name", nameList.get(i));
			seriesJson.put("type", "line");
			seriesJson.put("smooth", true);
			seriesJson.put("data", data);
//			System.out.println("nameList的值："+nameList.get(i)+";data数组大小："+data.size()+";"+data.toString());
//			System.out.println(seriesJson.toJSONString());
			series.add(seriesJson);
		}
		dataJson.put("series", series);
		
		jsonObject.put("data", dataJson);
		System.out.println(jsonObject.toJSONString());
		
		
		
		
//		List<PeakValleyEntity> list = peakValleyService.queryPeakValley(2, "测试", "2019-07-22", 1, 30,null);
//		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
//		int a = peakValleyService.queryPeakValleyCount(2, "测试", "2019-07-22", 1, 30, 1);
//		System.out.println("总数目：" + a);
	}
	
}
