package com.mh.eems;

import java.util.ArrayList;
import java.util.List;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.dto.RolesDto;
import com.mh.eems.dto.RoleAndPermissionDto;
import com.mh.eems.entity.PermissionEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.entity.ResponseInfoEntity;
import com.mh.eems.entity.RoleEntity;
import com.mh.eems.service.RoleService;
import com.mh.eems.util.JsonPackUtils;

public class RoleTest extends SpringTestCase {
	
	@Autowired
	private RoleService roleService;
	
//	@Test
//	public void queryAllRoles() {
//		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
//		ResponseEntity<RoleEntity> responseEntity = new ResponseEntity<RoleEntity>();
//		List<RoleEntity> roleEntities = roleService.queryAllRoles(1,10);
//		responseEntity.setCode(200);
//		responseEntity.setMsg("success");
//		responseEntity.setData(roleEntities);
//		responseEntity.setCount(roleService.queryRoleCount());
//		System.out.println(JSONObject.toJSON(responseEntity));
//	}

	@Test
	public void queryRoleAndPermission() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		ResponseInfoEntity responseEntity = new ResponseInfoEntity();
		RolesDto responseInfo1 = new RolesDto();
		List<RoleAndPermissionDto> testDto = new ArrayList<RoleAndPermissionDto>();
		try {
			testDto = roleService.queryRoleAndPermission((long) 1);
			System.out.println();
			responseInfo1.setPermissions(JSON.toJSON(testDto.get(0).getPermissions()));
			responseInfo1.setRoles(JSON.toJSON(testDto.get(0).getRoles()));
			responseEntity.setData(JSON.toJSON(responseInfo1));
			System.out.println(JSON.toJSON(responseEntity));
//			System.out.println(testDto.getRoleEntities().toString());
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}
	
//	@Test
//	public <T> void inertRole() {
//		RoleEntity roleEntity = new RoleEntity();
//		roleEntity.setRoleName("测试1");
//		roleEntity.setDesc("测试1");
//		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
//		// 插入角色
//		try {
//			roleService.insertRole(roleEntity);
//			Long a = roleEntity.getRoleId();
//			if (a != 0) {
//				// 插入角色和权限id，sys_role_permission
//				roleService.insertRoleAndPermisson();
//				JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
//				Object object = jsonPackUtils.ok(); 
//				System.out.println(JSON.toJSON(object));
//			}
//		} catch (Exception e) {
//			// TODO: handle exception
//			e.printStackTrace();
//		}
//	}
	
//	@Test
//	public <T> void deleteRole() {
//		Object object = null;
//		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
//		int a = roleService.deleteRoleById(10);
//		if (a != 0) {
//			// 删除角色和权限id，sys_role_permission
//			roleService.deleteRolePermissionById(10);
//			JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
//			object = JSON.toJSON(jsonPackUtils.ok()); 
//			System.out.println(JSON.toJSON(object));
//		}
//	}
	
//	@Test
//	public <T> void updateRoleAndPermission() {
//		Object object = null;
//		String receiveData = "{\r\n" + 
//				"    \"roleId\":1,\r\n" + 
//				"    \"roleName\":\"admin\",\r\n" + 
//				"    \"desc\":\"管理员\",\r\n" + 
//				"    \"permissions\":[\r\n" + 
//				"        {\r\n" + 
//				"            \"id\":1,\r\n" + 
//				"            \"isStatus\":1,\r\n" + 
//				"            \"name\":\"用量查询\"\r\n" + 
//				"        }\r\n" + 
//				"    ]\r\n" + 
//				"}";
//		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
//		// 获取对应的sys_role值，然后进行更新
//		RoleEntity roleEntity = new RoleEntity();
//		
//		// 解析receiveData
//		JSONObject jsonObject = JSONObject.parseObject(receiveData);
//		roleEntity.setRoleId(jsonObject.getLong("roleId"));
//		roleEntity.setRoleName(jsonObject.getString("roleName"));
//		roleEntity.setDesc(jsonObject.getString("desc"));
//		// 更新sys_role值
//		int a = roleService.updateRoleById(roleEntity);
//		System.out.println("----->>>>"+a);
//		if (a != 0) {
//			List<Permission> pList = new ArrayList<Permission>();
//			JSONArray jsonArray = jsonObject.getJSONArray("permissions");
//			for (int i = 0; i < jsonArray.size(); i++) {
//				Permission permission = new Permission();
//				JSONObject jsonObject2 = jsonArray.getJSONObject(i);
//				permission.setName(jsonObject2.getString("name"));
//				permission.setId(jsonObject2.getInteger("id").longValue());
//				permission.setIsStatus(jsonObject2.getInteger("isStatus"));
//				permission.setSort(roleEntity.getRoleId().intValue());
//				pList.add(permission);
//			}
//			// 更新sys_role_permission
//			try {
//				roleService.updateRolePermission(pList);
//			} catch (Exception e) {
//				// TODO: handle exception
//				e.printStackTrace();
//			}
//			
//			System.out.println(pList.get(0).getId());
//			JsonPackUtils<T> jsonPackUtils = new JsonPackUtils<>();
//			object = JSON.toJSON(jsonPackUtils.ok()); 
//			System.out.println(JSON.toJSON(object));
//		}
//	}

}
