package com.mh.eems;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.ReporterEntity;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.service.StatisticsService;

public class StatisticsReportTest extends SpringTestCase {
	
	@Autowired
	private StatisticsService statisticsService;
	
	@Test
	public void queryReport() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		Map<String, Object> map = new HashMap<String, Object>();
		map.put("levelId", null);
		map.put("levelName", null);
		map.put("queryType", null);
		map.put("page", 1);
		map.put("limit", 10);
		try {
			List<ReporterEntity> list =statisticsService.queryStatisticsReport(map);
		
		
	//		System.out.println(JSON.toJSONString(list,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
			int count = (int) map.get("result_count");
	//		System.out.println("总数目："+ count);
			
			// 全查询数据
			ResponseEntity<ReporterEntity> pEntity = new ResponseEntity<ReporterEntity>();
			pEntity.setCode(200);
			pEntity.setMsg("查询成功");
			pEntity.setCount(count);
			pEntity.setData(list);
			System.out.println(JSON.toJSONString(pEntity,SerializerFeature.PrettyFormat,SerializerFeature.WriteMapNullValue));
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}

}
