package com.mh.eems;

import java.util.List;

import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.annotation.Rollback;

import com.alibaba.fastjson.JSONObject;
import com.mh.eems.constants.UserConstants;
import com.mh.eems.datasource.DBIdentifier;
import com.mh.eems.entity.ResponseEntity;
import com.mh.eems.entity.SysLogEntity;
import com.mh.eems.entity.SysUserEntity;
import com.mh.eems.service.SysLogService;
import com.mh.eems.util.SysLogUtil;

public class SysLogTest extends SpringTestCase {
	
	@Autowired
	private SysLogService sysLogService;
	
	@Test
	@Rollback
	public void addLog() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		SysLogUtil sysLogUtil = new SysLogUtil();
		try {
			System.out.println(sysLogUtil.logSave("测试", "test", "test"));
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	@Test
	@Rollback
	public void querySysLogs() {
		DBIdentifier.setProjectCode(UserConstants.DATA_BASE);
		ResponseEntity<SysLogEntity> responseEntity = new ResponseEntity<SysLogEntity>();
		try {
			List<SysLogEntity> sysLogEntities = sysLogService.querySysLogs("2019-07-30", "2019-07-30", null, null, 1, 10);
			responseEntity.setCode(200);
			responseEntity.setMsg("success");
			responseEntity.setData(sysLogEntities);
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
		responseEntity.setCount(sysLogService.querySysLogsCount("2019-07-30", "2019-07-30", null, null, 1, 10));
		System.out.println(JSONObject.toJSON(responseEntity));
	}

}
